// DDS AD9854 Ansteuerung
//
// Marcus Pool
//
// www.Marcus-Pool.de
//
// Revision: 0.1
// 22.03.0
//
// Chip select wird nicht angesteuert

#include <main.h>

// Daten einzeln zum AD9854 takten und bernehmen
void DDS_write_word(int bits, int data)
    {
    // Daten bertragen
    for (int i=bits-1; i >= 0; i--)
       {
	// Daten zum AD9854 Bit fr Bit rausschieben
       if (data & (1L << i))
          {
			PORTD |= (1 << SDATA);			// Ausgangsbit setzen
          }
       else
          {
			PORTD &= ~(1 << SDATA);			// Ausgangsbit zurcksetzen
          }
		PORTD |= (1 << SCLK);				// toggle Clocksignal
		PORTD &=~(1 << SCLK);				// toggle Clocksignal

	   }
	PORTB |= (1 << IOUD);					// Daten intern bernehmen
	PORTB &=~(1 << IOUD);					// Signal zurcksetzen
    }

// Initialisieren des DDS mit Startwerten fr serielle Kommunikation
// MSB will be transmitted first
void Init_DDS(void)
	{
	PORTB |= (1 << MRESET);	//Master Reset einleiten
	PORTB &=~(1 << MRESET);	//Master Reset rcksetzen

	// Adresse whlen
	DDS_write_word(8, 0x07);	// schreibe Adresse 0x07 fr Control REgister
	// Daten senden
	DDS_write_word(8, 0x10);	// Powerdown Comparator
	DDS_write_word(8, 0x02);	// Referenz clock Frequenz Multiplizierer x4
	DDS_write_word(8, 0x00);	// Single tone Modus, internal Latch update
	DDS_write_word(8, 0x40);	// kein Sinc Filter

	// zweimal schreiben um sicher zu gehen
	// Adresse whlen
	DDS_write_word(8, 0x07);	// schreibe Adresse 0x07 fr Control REgister
	// Daten senden
	DDS_write_word(8, 0x10);	// Powerdown Comparator
	DDS_write_word(8, 0x02);	// Referenz clock Frequenz Multiplizierer x4
	DDS_write_word(8, 0x00);	// Single tone Modus, internal Latch update
	DDS_write_word(8, 0x40);	// kein Sinc Filter
	}


