#include <main.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <lcd.h>

volatile uint8_t key;

void start_menu (void)
{
	lcd_clrscr();					// lsche alles
	lcd_gotoxy(7,0);				// Erste Zeile
	lcd_puts("SDR Trx");
	lcd_gotoxy(0,1);
	lcd_puts("Frequenz:");
	lcd_gotoxy(0,2);
	lcd_puts("12.345.678 kHz");
	return;
}

void menu()
{
	lcd_clrscr();
	lcd_puts("1: LCD Helligkeit");
	lcd_gotoxy(0,1);
	lcd_puts("2:");
	lcd_gotoxy(0,2);
	lcd_puts("3:");
	lcd_gotoxy(0,3);
	lcd_puts("4:");
	while (key == 0) 
	{
		switch (key)
		{
			case 15: 		// Taste 1
				lcd_pwm();	// PWM Men aufrufen
				break;
			case 20:		// Taste 2
				break;
			case 25:		// Taste 3
				break;
			case 14:		// Taste 4
				break;
			case 12:		// Back
				start_menu();
				break;
			default:
				key = 0;
				break;
		}
	}
	key = 0;
	return;
}


void lcd_pwm (void)
{
	key = 0;
	lcd_clrscr();
	lcd_puts("Helligkeit");
	while (key == 0) 
	{
		switch (key)
		{
			case 15: 		// Taste 1
				OCR1A = 100;
				break;
			case 20:		// Taste 2
				OCR1A = 300;
				break;
			case 25:		// Taste 3
				OCR1A = 600;
				break;
			case 14:		// Taste 4
				OCR1A = 900;
				break;
			case 12:		// Back
				start_menu();
				break;
			default:
				key = 0;
				break;
		}
	}
	key = 0;
	return;
}

