// Bandwahl und Bandberprfung
//
// Marcus Pool, DG9BFJ
//
// www.Marcus-Pool.de
//
// Revision: 0.1
// 
// 23.06.09

#include <main.h>
#include <avr/eeprom.h>
#include <lcd.h>
#include <util/delay.h> 
#include <lcd_menu.h>
#include <stdlib.h>
#include <string.h>
#include <dds.h>
#include <dsp.h>

extern uint8_t vfo;							// benutzter VFO
extern uint8_t band_a;
extern uint8_t band_b;
extern uint8_t mode;

extern uint16_t Rx_Relais;					// Relais auf dem Rx Board
extern uint16_t Tx_Relais;					// Relais auf dem Tx Board

extern uint32_t EE_freq_160_A	EEMEM;		// letzte Frequenz im 160m Band
extern uint32_t EE_freq_80_A	EEMEM;		// letzte Frequenz im 80m Band
extern uint32_t EE_freq_40_A	EEMEM;		// letzte Frequenz im 40m Band
extern uint32_t EE_freq_30_A	EEMEM;		// letzte Frequenz im 30m Band
extern uint32_t EE_freq_20_A	EEMEM;		// letzte Frequenz im 20m Band
extern uint32_t EE_freq_17_A	EEMEM;		// letzte Frequenz im 17m Band
extern uint32_t EE_freq_15_A	EEMEM;		// letzte Frequenz im 15m Band
extern uint32_t EE_freq_12_A	EEMEM;		// letzte Frequenz im 12m Band
extern uint32_t EE_freq_10_A	EEMEM;		// letzte Frequenz im 10m Band
extern uint32_t EE_freq_6_A		EEMEM;		// letzte Frequenz im 6m Band

extern uint32_t EE_freq_160_B	EEMEM;		// letzte Frequenz im 160m Band
extern uint32_t EE_freq_80_B	EEMEM;		// letzte Frequenz im 80m Band
extern uint32_t EE_freq_40_B	EEMEM;		// letzte Frequenz im 40m Band
extern uint32_t EE_freq_30_B	EEMEM;		// letzte Frequenz im 30m Band
extern uint32_t EE_freq_20_B	EEMEM;		// letzte Frequenz im 20m Band
extern uint32_t EE_freq_17_B	EEMEM;		// letzte Frequenz im 17m Band
extern uint32_t EE_freq_15_B	EEMEM;		// letzte Frequenz im 15m Band
extern uint32_t EE_freq_12_B	EEMEM;		// letzte Frequenz im 12m Band
extern uint32_t EE_freq_10_B	EEMEM;		// letzte Frequenz im 10m Band
extern uint32_t EE_freq_6_B		EEMEM;		// letzte Frequenz im 6m Band

extern uint32_t EE_MODE_160_A	EEMEM;		// letzter Mode im 160m Band
extern uint32_t EE_MODE_80_A	EEMEM;		// letzter Mode im 80m Band
extern uint32_t EE_MODE_40_A	EEMEM;		// letzter Mode im 40m Band
extern uint32_t EE_MODE_30_A	EEMEM;		// letzter Mode im 30m Band
extern uint32_t EE_MODE_20_A	EEMEM;		// letzter Mode im 20m Band
extern uint32_t EE_MODE_17_A	EEMEM;		// letzter Mode im 17m Band
extern uint32_t EE_MODE_15_A	EEMEM;		// letzter Mode im 15m Band
extern uint32_t EE_MODE_12_A	EEMEM;		// letzter Mode im 12m Band
extern uint32_t EE_MODE_10_A	EEMEM;		// letzter Mode im 10m Band
extern uint32_t EE_MODE_6_A		EEMEM;		// letzter Mode im 6m Band

extern uint32_t EE_MODE_160_B	EEMEM;		// letzter Mode im 160m Band
extern uint32_t EE_MODE_80_B	EEMEM;		// letzter Mode im 80m Band
extern uint32_t EE_MODE_40_B	EEMEM;		// letzter Mode im 40m Band
extern uint32_t EE_MODE_30_B	EEMEM;		// letzter Mode im 30m Band
extern uint32_t EE_MODE_20_B	EEMEM;		// letzter Mode im 20m Band
extern uint32_t EE_MODE_17_B	EEMEM;		// letzter Mode im 17m Band
extern uint32_t EE_MODE_15_B	EEMEM;		// letzter Mode im 15m Band
extern uint32_t EE_MODE_12_B	EEMEM;		// letzter Mode im 12m Band
extern uint32_t EE_MODE_10_B	EEMEM;		// letzter Mode im 10m Band
extern uint32_t EE_MODE_6_B		EEMEM;		// letzter Mode im 6m Band

extern uint8_t EE_ANT_160		EEMEM;		// ANT im 160m Band
extern uint8_t EE_ANT_80		EEMEM;		// ANT im 80m Band
extern uint8_t EE_ANT_40		EEMEM;		// ANT im 40m Band
extern uint8_t EE_ANT_30		EEMEM;		// ANT im 30m Band
extern uint8_t EE_ANT_20		EEMEM;		// ANT im 20m Band
extern uint8_t EE_ANT_17		EEMEM;		// ANT im 17m Band
extern uint8_t EE_ANT_15		EEMEM;		// ANT im 15m Band
extern uint8_t EE_ANT_12		EEMEM;		// ANT im 12m Band
extern uint8_t EE_ANT_10		EEMEM;		// ANT im 10m Band
extern uint8_t EE_ANT_6			EEMEM;		// ANT im 6m Band


///////////////////////////////////////////////////////////////////////////////
//
//	Frequenz vom jeweiligen Band im EEPROM speichern
//
///////////////////////////////////////////////////////////////////////////////
void save_band(uint32_t freq_hz)
{
		PORTG |= (1<<2); // Summer an
		_delay_ms(2);
		PORTG &= ~(1<<2);// Summer aus

	if (vfo == 0x00)
	{
		if (band_a == 0x01)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_160_A, sizeof(uint32_t));	// Frequenz speichern
		else if (band_a == 0x02)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_80_A, sizeof(uint32_t));	// Frequenz speichern
		else if (band_a == 0x03)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_40_A, sizeof(uint32_t));	// Frequenz speichern
		else if (band_a == 0x04)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_30_A, sizeof(uint32_t));	// Frequenz speichern
		else if (band_a == 0x05)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_20_A, sizeof(uint32_t));	// Frequenz speichern
		else if (band_a == 0x06)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_17_A, sizeof(uint32_t));	// Frequenz speichern
		else if (band_a == 0x07)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_15_A, sizeof(uint32_t));	// Frequenz speichern
		else if (band_a == 0x08)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_12_A, sizeof(uint32_t));	// Frequenz speichern
		else if (band_a == 0x09)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_10_A, sizeof(uint32_t));	// Frequenz speichern
		else if (band_a == 0x0A)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_6_A, sizeof(uint32_t));	// Frequenz speichern
	}
	else
	{
		if (band_b == 0x01)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_160_B, sizeof(uint32_t));	// Frequenz speichern
		else if (band_b == 0x02)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_80_B, sizeof(uint32_t));	// Frequenz speichern
		else if (band_b == 0x03)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_40_B, sizeof(uint32_t));	// Frequenz speichern
		else if (band_b == 0x04)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_30_B, sizeof(uint32_t));	// Frequenz speichern
		else if (band_b == 0x05)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_20_B, sizeof(uint32_t));	// Frequenz speichern
		else if (band_b == 0x06)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_17_B, sizeof(uint32_t));	// Frequenz speichern
		else if (band_b == 0x07)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_15_B, sizeof(uint32_t));	// Frequenz speichern
		else if (band_b == 0x08)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_12_B, sizeof(uint32_t));	// Frequenz speichern
		else if (band_b == 0x09)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_10_B, sizeof(uint32_t));	// Frequenz speichern
		else if (band_b == 0x0A)
			eeprom_write_block((uint32_t *)&freq_hz, (uint8_t*) &EE_freq_6_B, sizeof(uint32_t));	// Frequenz speichern
	}
}


///////////////////////////////////////////////////////////////////////////////
//
//	Frequenz vom jeweiligen Band aus dem EEPROM laden
//
///////////////////////////////////////////////////////////////////////////////
uint32_t load_band(void)
{
	uint32_t freq;
	if (vfo == 0x00) 													// benutze VFO A
	{
		if (band_a == 0x01)
			eeprom_read_block(&freq, &EE_freq_160_A, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_a == 0x02)
			eeprom_read_block(&freq, &EE_freq_80_A, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_a == 0x03)
			eeprom_read_block(&freq, &EE_freq_40_A, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_a == 0x04)
			eeprom_read_block(&freq, &EE_freq_30_A, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_a == 0x05)
			eeprom_read_block(&freq, &EE_freq_20_A, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_a == 0x06)
			eeprom_read_block(&freq, &EE_freq_17_A, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_a == 0x07)
			eeprom_read_block(&freq, &EE_freq_15_A, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_a == 0x08)
			eeprom_read_block(&freq, &EE_freq_12_A, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_a == 0x09)
			eeprom_read_block(&freq, &EE_freq_10_A, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_a == 0x0A)
			eeprom_read_block(&freq, &EE_freq_6_A, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
	}
	else 																// benutze VFO B
	{
		if (band_b == 0x01)
			eeprom_read_block(&freq, &EE_freq_160_B, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_b == 0x02)
			eeprom_read_block(&freq, &EE_freq_80_B, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_b == 0x03)
			eeprom_read_block(&freq, &EE_freq_40_B, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_b == 0x04)
			eeprom_read_block(&freq, &EE_freq_30_B, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_b == 0x05)
			eeprom_read_block(&freq, &EE_freq_20_B, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_b == 0x06)
			eeprom_read_block(&freq, &EE_freq_17_B, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_b == 0x07)
			eeprom_read_block(&freq, &EE_freq_15_B, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_b == 0x08)
			eeprom_read_block(&freq, &EE_freq_12_B, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_b == 0x09)
			eeprom_read_block(&freq, &EE_freq_10_B, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
		else if (band_b == 0x0A)
			eeprom_read_block(&freq, &EE_freq_6_B, sizeof(uint32_t));	// Frequenz aus EEPROM lesen
	}
//	Init_DSP(mode, vfo);												// den DSP initialisieren
	return freq;
}



///////////////////////////////////////////////////////////////////////////////
//
//	Mode vom jeweiligen Band aus dem EEPROM laden
//
///////////////////////////////////////////////////////////////////////////////
uint8_t load_mode(uint8_t band, uint8_t vfo)
{
	uint8_t temp = 0;
	if (vfo == 0x00)													// VFO A gewhlt
	{
		if (band == 0x01)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_160_A);			// Lese letzten Modus
		else if (band == 0x02)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_80_A);			// Lese letzten Modus
		else if (band == 0x03)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_40_A);			// Lese letzten Modus
		else if (band == 0x04)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_30_A);			// Lese letzten Modus
		else if (band == 0x05)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_20_A);			// Lese letzten Modus
		else if (band == 0x06)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_17_A);			// Lese letzten Modus
		else if (band == 0x07)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_15_A);			// Lese letzten Modus
		else if (band == 0x08)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_12_A);			// Lese letzten Modus
		else if (band == 0x09)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_10_A);			// Lese letzten Modus
		else if (band == 0x0A)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_6_A);			// Lese letzten Modus
	}
	else																// VFO B gewhlt
	{
		if (band == 0x01)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_160_B);			// Lese letzten Modus
		else if (band == 0x02)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_80_B);			// Lese letzten Modus
		else if (band == 0x03)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_40_B);			// Lese letzten Modus
		else if (band == 0x04)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_30_B);			// Lese letzten Modus
		else if (band == 0x05)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_20_B);			// Lese letzten Modus
		else if (band == 0x06)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_17_B);			// Lese letzten Modus
		else if (band == 0x07)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_15_B);			// Lese letzten Modus
		else if (band == 0x08)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_12_B);			// Lese letzten Modus
		else if (band == 0x09)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_10_B);			// Lese letzten Modus
		else if (band == 0x0A)
			temp = eeprom_read_byte((uint8_t*)&EE_MODE_6_B);			// Lese letzten Modus
	}
	return temp;
}
///////////////////////////////////////////////////////////////////////////////
//
//	Mode vom jeweiligen Band aus dem EEPROM speichern
//
///////////////////////////////////////////////////////////////////////////////
void save_mode(uint8_t mode, uint8_t vfo, uint8_t band)
{
	if (vfo == 0x00)
	{
		if (band == 0x01)
			eeprom_write_byte((uint8_t*)&EE_MODE_160_A, mode);			// Mode speichern
		else if (band == 0x02)
			eeprom_write_byte((uint8_t*)&EE_MODE_80_A, mode);			// Mode speichern
		else if (band == 0x03)
			eeprom_write_byte((uint8_t*)&EE_MODE_40_A, mode);			// Mode speichern
		else if (band == 0x04)
			eeprom_write_byte((uint8_t*)&EE_MODE_30_A, mode);			// Mode speichern
		else if (band == 0x05)
			eeprom_write_byte((uint8_t*)&EE_MODE_20_A, mode);			// Mode speichern
		else if (band == 0x06)
			eeprom_write_byte((uint8_t*)&EE_MODE_17_A, mode);			// Mode speichern
		else if (band == 0x07)
			eeprom_write_byte((uint8_t*)&EE_MODE_15_A, mode);			// Mode speichern
		else if (band == 0x08)
			eeprom_write_byte((uint8_t*)&EE_MODE_12_A, mode);			// Mode speichern
		else if (band == 0x09)
			eeprom_write_byte((uint8_t*)&EE_MODE_10_A, mode);			// Mode speichern
		else if (band == 0x0A)
			eeprom_write_byte((uint8_t*)&EE_MODE_6_A, mode);			// Mode speichern
	}
	else
	{
		if (band == 0x01)
			eeprom_write_byte((uint8_t*)&EE_MODE_160_B, mode);			// Mode speichern
		else if (band == 0x02)
			eeprom_write_byte((uint8_t*)&EE_MODE_80_B, mode);			// Mode speichern
		else if (band == 0x03)
			eeprom_write_byte((uint8_t*)&EE_MODE_40_B, mode);			// Mode speichern
		else if (band == 0x04)
			eeprom_write_byte((uint8_t*)&EE_MODE_30_B, mode);			// Mode speichern
		else if (band == 0x05)
			eeprom_write_byte((uint8_t*)&EE_MODE_20_B, mode);			// Mode speichern
		else if (band == 0x06)
			eeprom_write_byte((uint8_t*)&EE_MODE_17_B, mode);			// Mode speichern
		else if (band == 0x07)
			eeprom_write_byte((uint8_t*)&EE_MODE_15_B, mode);			// Mode speichern
		else if (band == 0x08)
			eeprom_write_byte((uint8_t*)&EE_MODE_12_B, mode);			// Mode speichern
		else if (band == 0x09)
			eeprom_write_byte((uint8_t*)&EE_MODE_10_B, mode);			// Mode speichern
		else if (band == 0x0A)
			eeprom_write_byte((uint8_t*)&EE_MODE_6_B, mode);			// Mode speichern
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//	Antenne vom jeweiligen Band schalten
//
///////////////////////////////////////////////////////////////////////////////
void set_ant (uint8_t ant_temp)
{
	uint8_t temp = 0;

	temp = ant_temp & 0x0F;												// nur Rx Antenne auswerten
	Tx_Relais &= 0xFE3F;
	if (temp == 0x01)
		Tx_Relais |= 0x0180;
	else if (temp == 0x02)
		Tx_Relais |= 0x0140;
	else if (temp == 0x03)
		Tx_Relais |= 0x00C0;
}


///////////////////////////////////////////////////////////////////////////////
//
//	Antenne vom jeweiligen Band im dem EEPROM speichern
//
///////////////////////////////////////////////////////////////////////////////
void save_ant(uint8_t band, uint8_t ANT)
{
	if (band == 0x01)
		eeprom_write_byte((uint8_t*)&EE_ANT_160, ANT);				// ANT speichern
	else if (band == 0x02)
		eeprom_write_byte((uint8_t*)&EE_ANT_80, ANT);				// ANT speichern
	else if (band == 0x03)
		eeprom_write_byte((uint8_t*)&EE_ANT_40, ANT);				// ANT speichern
	else if (band == 0x04)
		eeprom_write_byte((uint8_t*)&EE_ANT_30, ANT);				// ANT speichern
	else if (band == 0x05)
		eeprom_write_byte((uint8_t*)&EE_ANT_20, ANT);				// ANT speichern
	else if (band == 0x06)
		eeprom_write_byte((uint8_t*)&EE_ANT_17, ANT);				// ANT speichern
	else if (band == 0x07)
		eeprom_write_byte((uint8_t*)&EE_ANT_15, ANT);				// ANT speichern
	else if (band == 0x08)	
		eeprom_write_byte((uint8_t*)&EE_ANT_12, ANT);				// ANT speichern
	else if (band == 0x09)
		eeprom_write_byte((uint8_t*)&EE_ANT_10, ANT);				// ANT speichern
	else if (band == 0x0A)
		eeprom_write_byte((uint8_t*)&EE_ANT_6, ANT);				// ANT speichern
}

///////////////////////////////////////////////////////////////////////////////
//
//	Antenne vom jeweiligen Band aus dem EEPROM laden
//
///////////////////////////////////////////////////////////////////////////////
uint8_t load_ant(uint8_t band)
{
	uint8_t temp = 0;
	if (band == 0x01)
		temp = eeprom_read_byte((uint8_t*)&EE_ANT_160);				// Lese letzte Antenneneinstellung
	else if (band == 0x02)
		temp = eeprom_read_byte((uint8_t*)&EE_ANT_80);				// Lese letzte Antenneneinstellung
	else if (band == 0x03)
		temp = eeprom_read_byte((uint8_t*)&EE_ANT_40);				// Lese letzte Antenneneinstellung
	else if (band == 0x04)
		temp = eeprom_read_byte((uint8_t*)&EE_ANT_30);				// Lese letzte Antenneneinstellung
	else if (band == 0x05)
		temp = eeprom_read_byte((uint8_t*)&EE_ANT_20);				// Lese letzte Antenneneinstellung
	else if (band == 0x06)
		temp = eeprom_read_byte((uint8_t*)&EE_ANT_17);				// Lese letzte Antenneneinstellung
	else if (band == 0x07)
		temp = eeprom_read_byte((uint8_t*)&EE_ANT_15);				// Lese letzte Antenneneinstellung
	else if (band == 0x08)
		temp = eeprom_read_byte((uint8_t*)&EE_ANT_12);				// Lese letzte Antenneneinstellung
	else if (band == 0x09)
		temp = eeprom_read_byte((uint8_t*)&EE_ANT_10);				// Lese letzte Antenneneinstellung
	else if (band == 0x0A)
		temp = eeprom_read_byte((uint8_t*)&EE_ANT_6);				// Lese letzte Antenneneinstellung
//	set_ant(temp);													// schalte aktuelle Antenne ein
	return temp;
}



