#include <main.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <lcd.h>

#include <util/delay.h> 
#include <string.h>
#include <stdio.h>>

extern int8_t   	enc_delta=0;      // -128 ... 127

extern uint16_t leds;					// Zustand der LEDs

extern struct BitVariablen{
    int menu_aktiv		:1;					// ein Men ist aktiviert
	int freq_input  	:1;					// 
	int	freq_update 	:1;					// 
	int freq_update_lcd	:1;					// auf dem LCD Frequenz aktualisieren
}bitvar;


///////////////////////////////////////////////////////////////////////////////
int8_t encoder_read(void)         					// Encoderwerte auslesen
{
	int8_t val;
 	
	if (!(leds & Lock_LED_an))						// ist das bit gelscht?
	{
		if ((bitvar.freq_input != 1) && (bitvar.menu_aktiv != 1))// nur Frequenz ndern wenn kein Men aktiv ist
		{
			cli();
			val = enc_delta;
			enc_delta = val & 3;
			sei();
			bitvar.freq_update = 1;					// Frequenz gendert
			bitvar.freq_update_lcd = 1;				// LCD Frequenz gendert
			return val >> 2;
		}
		return 0;
	}
	return 0;
}
///////////////////////////////////////////////////////////////////////////////
