#include <main.h>
#include <avr/eeprom.h>
#include <lcd.h>
#include <util/delay.h> 
#include <lcd_menu.h>
#include <stdlib.h>
#include <string.h>
#include <rit.h>
#include <dds.h>
#include <band.h>
#include <dsp.h>
#include <outputs.h>

extern uint8_t step;			// Encoder Schrittweite
extern uint8_t beep_on_off;		// Tastenton
extern uint8_t mode;
extern uint8_t band_a;
extern uint8_t band_b;
extern uint8_t ant;

extern uint16_t menu_nr; 
extern uint16_t LCD_PWM;
extern uint16_t leds;			// Zustand der LEDs
extern uint16_t Rx_Relais;		// Relais auf dem Rx Board
extern uint16_t Tx_Relais;		// Relais auf dem Tx Board
extern uint8_t vfo;				// benutzter VFO

extern uint32_t freq_hz;		// speichert die Frequenz in Hz

volatile char frequenz[11];

extern uint16_t LCD_PWM 		EEMEM;		// PWM Wert fr LCD Beleuchtung
extern uint8_t  Tastenton 		EEMEM;		// Tastenton an/aus
extern uint8_t  Schrittweite	EEMEM;		// Schritweite fr Encoder
extern uint8_t  EE_AGC_A		EEMEM;		// AGC an (0) oder aus (1)
extern uint8_t  EE_AGC_B		EEMEM;		// AGC an (0) oder aus (1)
extern uint8_t  EE_Filter_A		EEMEM;		// Filter des DSP
extern uint8_t  EE_Filter_B		EEMEM;		// Filter des DSP
extern uint8_t  EE_VFO_AB		EEMEM;		// VFO A oder B
extern uint8_t  EE_BAND_A		EEMEM;		// Bandwahl
extern uint8_t  EE_BAND_B		EEMEM;		// Bandwahl
extern uint16_t EE_LED_A		EEMEM;		// I2C LED Status
extern uint16_t EE_LED_B		EEMEM;		// I2C LED Status
extern uint32_t EE_ATT_A		EEMEM;		// Attenuator fr VFO A
extern uint32_t EE_ATT_B		EEMEM;		// Attenuator fr VFO B
extern uint32_t EE_freq_160_A	EEMEM;		// letzte Frequenz im 160m Band
extern uint32_t EE_freq_80_A	EEMEM;		// letzte Frequenz im 80m Band
extern uint32_t EE_freq_40_A	EEMEM;		// letzte Frequenz im 40m Band
extern uint32_t EE_freq_30_A	EEMEM;		// letzte Frequenz im 30m Band
extern uint32_t EE_freq_20_A	EEMEM;		// letzte Frequenz im 20m Band
extern uint32_t EE_freq_17_A	EEMEM;		// letzte Frequenz im 17m Band
extern uint32_t EE_freq_15_A	EEMEM;		// letzte Frequenz im 15m Band
extern uint32_t EE_freq_12_A	EEMEM;		// letzte Frequenz im 12m Band
extern uint32_t EE_freq_10_A	EEMEM;		// letzte Frequenz im 10m Band
extern uint32_t EE_freq_6_A		EEMEM;		// letzte Frequenz im 6m Band
extern uint32_t EE_freq_160_B	EEMEM;		// letzte Frequenz im 160m Band
extern uint32_t EE_freq_80_B	EEMEM;		// letzte Frequenz im 80m Band
extern uint32_t EE_freq_40_B	EEMEM;		// letzte Frequenz im 40m Band
extern uint32_t EE_freq_30_B	EEMEM;		// letzte Frequenz im 30m Band
extern uint32_t EE_freq_20_B	EEMEM;		// letzte Frequenz im 20m Band
extern uint32_t EE_freq_17_B	EEMEM;		// letzte Frequenz im 17m Band
extern uint32_t EE_freq_15_B	EEMEM;		// letzte Frequenz im 15m Band
extern uint32_t EE_freq_12_B	EEMEM;		// letzte Frequenz im 12m Band
extern uint32_t EE_freq_10_B	EEMEM;		// letzte Frequenz im 10m Band
extern uint32_t EE_freq_6_B		EEMEM;		// letzte Frequenz im 6m Band

extern uint32_t EE_MODE_160_A	EEMEM;		// letzter Mode im 160m Band
extern uint32_t EE_MODE_80_A	EEMEM;		// letzter Mode im 80m Band
extern uint32_t EE_MODE_40_A	EEMEM;		// letzter Mode im 40m Band
extern uint32_t EE_MODE_30_A	EEMEM;		// letzter Mode im 30m Band
extern uint32_t EE_MODE_20_A	EEMEM;		// letzter Mode im 20m Band
extern uint32_t EE_MODE_17_A	EEMEM;		// letzter Mode im 17m Band
extern uint32_t EE_MODE_15_A	EEMEM;		// letzter Mode im 15m Band
extern uint32_t EE_MODE_12_A	EEMEM;		// letzter Mode im 12m Band
extern uint32_t EE_MODE_10_A	EEMEM;		// letzter Mode im 10m Band
extern uint32_t EE_MODE_6_A		EEMEM;		// letzter Mode im 6m Band

extern uint32_t EE_MODE_160_B	EEMEM;		// letzter Mode im 160m Band
extern uint32_t EE_MODE_80_B	EEMEM;		// letzter Mode im 80m Band
extern uint32_t EE_MODE_40_B	EEMEM;		// letzter Mode im 40m Band
extern uint32_t EE_MODE_30_B	EEMEM;		// letzter Mode im 30m Band
extern uint32_t EE_MODE_20_B	EEMEM;		// letzter Mode im 20m Band
extern uint32_t EE_MODE_17_B	EEMEM;		// letzter Mode im 17m Band
extern uint32_t EE_MODE_15_B	EEMEM;		// letzter Mode im 15m Band
extern uint32_t EE_MODE_12_B	EEMEM;		// letzter Mode im 12m Band
extern uint32_t EE_MODE_10_B	EEMEM;		// letzter Mode im 10m Band
extern uint32_t EE_MODE_6_B		EEMEM;		// letzter Mode im 6m Band

extern uint8_t EE_ANT_160		EEMEM;		// ANT im 160m Band
extern uint8_t EE_ANT_80		EEMEM;		// ANT im 80m Band
extern uint8_t EE_ANT_40		EEMEM;		// ANT im 40m Band
extern uint8_t EE_ANT_30		EEMEM;		// ANT im 30m Band
extern uint8_t EE_ANT_20		EEMEM;		// ANT im 20m Band
extern uint8_t EE_ANT_17		EEMEM;		// ANT im 17m Band
extern uint8_t EE_ANT_15		EEMEM;		// ANT im 15m Band
extern uint8_t EE_ANT_12		EEMEM;		// ANT im 12m Band
extern uint8_t EE_ANT_10		EEMEM;		// ANT im 10m Band
extern uint8_t EE_ANT_6			EEMEM;		// ANT im 6m Band

extern struct BitVariablen{
    int menu_aktiv		:1;					// ein Men ist aktiviert
	int freq_input  	:1;					// Frequenzeingabe via 10er Tastatur aktiviert
	int	freq_update 	:1;					// 
	int freq_update_lcd	:1;					// auf dem LCD Frequenz aktualisieren
	int tx_on			:1;					// Sender eingeschaltet
	int ptt_schalten	:1;					// PTT umgeschaltet
	int rit_aktiv		:1;					// RIT Funktion aktiv
}bitvar;

///////////////////////////////////////////////////////////////////////////////
//
//	Initialisiere EEPROM nach Neuprogrammierung oder auslesen der alten Werte
//
///////////////////////////////////////////////////////////////////////////////
void Init_AVR(void)
{
	uint8_t temp = 0, band = 0;
	uint32_t clear = 0;
	lcd_clrscr();
	lcd_puts("      SDR Trx");
	lcd_gotoxy(7,1); lcd_puts("von");
	lcd_gotoxy(1,2); lcd_puts("Marcus Pool DG9BFJ");
	lcd_gotoxy(4,3); lcd_puts("Version 0.47");
 	temp = eeprom_read_byte((uint8_t*)&Schrittweite);	// alle EEPROM Speicherzellen = 0xFF?

	_delay_ms(500);

	if (temp >= 0x07)									// EEPROM leer nach neuprogrammierung
	{
		lcd_gotoxy(19,3); lcd_puts("I");				// unten rechts ein "I" anzeigen bei Initialisierung
		eeprom_write_byte(&Schrittweite, 0x05); 		// Schrittweite 100 Hz
		step = 0x05;
		eeprom_write_byte(&Tastenton, 0x00); 			// Tastenton aus
		beep_on_off = 0;
		eeprom_write_word(&LCD_PWM, 0); 				// Displayhelligkeit auf Stufe 9
		OCR1A = 0;

		eeprom_write_byte((uint8_t*)&EE_MODE_160_A, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_80_A, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_40_A, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_30_A, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_20_A, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_17_A, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_15_A, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_12_A, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_10_A, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_6_A, 0x14); // Mode speichern

		eeprom_write_byte((uint8_t*)&EE_MODE_160_B, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_80_B, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_40_B, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_30_B, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_20_B, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_17_B, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_15_B, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_12_B, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_10_B, 0x14);// Mode speichern
		eeprom_write_byte((uint8_t*)&EE_MODE_6_B, 0x14); // Mode speichern

		eeprom_write_byte((uint8_t*)&EE_ANT_160, 0x11);	// mit Antenne 1 als Rx und Tx starten
		eeprom_write_byte((uint8_t*)&EE_ANT_80, 0x11);	// mit Antenne 1 als Rx und Tx starten
		eeprom_write_byte((uint8_t*)&EE_ANT_40, 0x11);	// mit Antenne 1 als Rx und Tx starten
		eeprom_write_byte((uint8_t*)&EE_ANT_30, 0x11);	// mit Antenne 1 als Rx und Tx starten
		eeprom_write_byte((uint8_t*)&EE_ANT_20, 0x11);	// mit Antenne 1 als Rx und Tx starten
		eeprom_write_byte((uint8_t*)&EE_ANT_17, 0x11);	// mit Antenne 1 als Rx und Tx starten
		eeprom_write_byte((uint8_t*)&EE_ANT_15, 0x11);	// mit Antenne 1 als Rx und Tx starten
		eeprom_write_byte((uint8_t*)&EE_ANT_12, 0x11);	// mit Antenne 1 als Rx und Tx starten
		eeprom_write_byte((uint8_t*)&EE_ANT_10, 0x11);	// mit Antenne 1 als Rx und Tx starten
		eeprom_write_byte((uint8_t*)&EE_ANT_6, 0x11); 	// mit Antenne 1 als Rx und Tx starten
		mode = 0x14;
		eeprom_write_byte((uint8_t*)&EE_AGC_A, 0x01);	// mit AGC an starten
		eeprom_write_byte((uint8_t*)&EE_AGC_B, 0x01);	// mit AGC an starten
		eeprom_write_byte((uint8_t*)&EE_Filter_A, 0x22);// mit Filter 4 (LSB SSB) starten
		eeprom_write_byte((uint8_t*)&EE_Filter_B, 0x22);// mit Filter 4 (LSB SSB) starten
		vfo = 0;
		eeprom_write_byte((uint8_t*)&EE_VFO_AB, 0x00);	// starte mit VFO A
		eeprom_write_word((uint16_t*)&EE_LED_A, 0x00);	// LED Status Anzeige, siehe "outputs.c"
		eeprom_write_word((uint16_t*)&EE_LED_B, 0x00);	// LED Status Anzeige, siehe "outputs.c"
		leds = 0x00;
		eeprom_write_byte((uint8_t*)&EE_BAND_A, 0x02);	// starte mit 80m Band
		eeprom_write_byte((uint8_t*)&EE_BAND_B, 0x02);	// starte mit 40m Band
		band_a = 0x02; band_b = 0x02;
		eeprom_write_byte((uint8_t*)&temp, 0x14);		// speichere LSB und SSB
		freq_hz = 1810000; 
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_160_A, sizeof(uint32_t));//Startfrequenz = 1,81 MHz
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_160_B, sizeof(uint32_t));//Startfrequenz = 1,81 MHz
		freq_hz = 3500000;
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_80_A, sizeof(uint32_t));// Startfrequenz = 3,5 MHz
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_80_B, sizeof(uint32_t));// Startfrequenz = 3,5 MHz
		freq_hz = 7000000;
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_40_A, sizeof(uint32_t));// Startfrequenz = 7 MHz
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_40_B, sizeof(uint32_t));// Startfrequenz = 7 MHz
		freq_hz = 10100000;
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_30_A, sizeof(uint32_t));// Startfrequenz = 10,1 MHz
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_30_B, sizeof(uint32_t));// Startfrequenz = 10,1 MHz
		freq_hz = 14000000;
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_20_A, sizeof(uint32_t));// Startfrequenz = 14 MHz
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_20_B, sizeof(uint32_t));// Startfrequenz = 14 MHz
		freq_hz = 18068000;
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_17_A, sizeof(uint32_t));// Startfrequenz = 18,068 MHz
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_17_B, sizeof(uint32_t));// Startfrequenz = 18,068 MHz
		freq_hz = 21000000;
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_15_A, sizeof(uint32_t));// Startfrequenz = 21 MHz
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_15_B, sizeof(uint32_t));// Startfrequenz = 21 MHz
		freq_hz = 24890000;
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_12_A, sizeof(uint32_t));// Startfrequenz = 24,89 MHz
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_12_B, sizeof(uint32_t));// Startfrequenz = 24,89 MHz
		freq_hz = 28000000;
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_10_A, sizeof(uint32_t));// Startfrequenz = 28 MHz
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_10_B, sizeof(uint32_t));// Startfrequenz = 28 MHz
		freq_hz = 50080000;
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_6_A, sizeof(uint32_t)); // Startfrequenz = 50,08 MHz
		eeprom_write_block((uint32_t*)&freq_hz, (uint8_t*) &EE_freq_6_B, sizeof(uint32_t)); // Startfrequenz = 50,08 MHz
		freq_hz = 3500000;
		eeprom_write_block((uint32_t*)&clear, (uint8_t*) &EE_ATT_A, sizeof(uint32_t)); 		// alle Dmpfungsglieder aus
		eeprom_write_block((uint32_t*)&clear, (uint8_t*) &EE_ATT_B, sizeof(uint32_t)); 		// alle Dmpfungsglieder aus
	}
	else
	{
		OCR1A = eeprom_read_word((uint16_t*)&LCD_PWM);		// PWM Wert fr Hintergrundbeleuchtung laden
		beep_on_off = eeprom_read_byte((uint8_t*)&Tastenton);//Tastenton laden
		step = eeprom_read_byte((uint8_t*)&Schrittweite);	// Schrittweite laden
		vfo = eeprom_read_byte((uint8_t*)&EE_VFO_AB);		// Lese letzten VFO
		band_a = eeprom_read_byte((uint8_t*)&EE_BAND_A);	// Bandwahl laden
		band_b = eeprom_read_byte((uint8_t*)&EE_BAND_B);	// Bandwahl laden
	}	
	if (vfo == 0x00)
	{
		band = band_a;
		leds = eeprom_read_word((uint16_t*)&EE_LED_A);		// Zustand der LEDs laden
		AGC = eeprom_read_byte((uint8_t*)&EE_AGC_A);		// AGC frs aktuelle Band laden
		mode = load_mode(band, vfo);						// lade aktuellen Mode
	}
	else
	{
		band = band_b;
		leds = eeprom_read_word((uint16_t*)&EE_LED_B);		// Zustand der LEDs laden
		AGC = eeprom_read_byte((uint8_t*)&EE_AGC_B);		// AGC frs aktuelle Band laden
		mode = load_mode(band, vfo);						// lade aktuellen Mode
	}
	Init_DSP(mode, vfo);									// Initialisiere DSP
	if (AGC == 1)
		leds |= AGC_LED_an;									// Led fr AGC an
	else
		leds &= AGC_LED_aus;								// Led fr AGC aus
	leds &= PTT_LED_aus;									// Led aus
	ant = load_ant(band);									// aktuelle Antenneneinstellung laden
	freq_hz = load_band();									// die Frequenz vom neuen Band laden
	_delay_ms(1000);										// warten bis Spannung fr DSP ok ist
	start_menu();
	LED_onoff(Init); 
	if (leds & RIT_an)										// ist das bit gesetzt?
		leds &= RIT_aus;									// dann LED aus
	else
		leds |= RIT_an;										
	rit_LED();
}
