#include <main.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <lcd.h>
#include <encoder.h>
#include <rit.h>
#include <util/delay.h> 
#include <stdlib.h>
#include <string.h>
#include <inttypes.h>
#include <stdio.h>
#include <dds.h>
#include <band.h>
#include <dsp.h>
#include <outputs.h>
#include <global.h>


void EINSTELLUNGEN(uint8_t, uint8_t);
void M_ANT(uint8_t, uint8_t);

uint8_t draw; 
uint8_t stelle;

uint8_t Tastenton;			// EEPROM Speicher
uint8_t beep_on_off;		// Tastenton
uint8_t Schrittweite;		// Schrittweite des Encoders

volatile char frequenz[11];
volatile char frequenz_alt[11];

extern uint8_t freq_counter;
extern uint8_t step;
extern uint8_t mode;
extern uint8_t mode_temp;
extern uint8_t band_a;
extern uint8_t band_b;
extern uint8_t vfo;
extern uint8_t ant;

extern uint16_t menu_nr; 
extern uint16_t LCD_PWM;
extern uint16_t leds;					// Zustand der LEDs
extern uint16_t Rx_Relais;				// Relais auf dem Rx Board
extern uint16_t Tx_Relais;				// Relais auf dem Tx Board

extern uint8_t  EE_AGC_A		EEMEM;	// AGC an (0) oder aus (1)
extern uint8_t  EE_AGC_B		EEMEM;	// AGC an (0) oder aus (1)
extern uint8_t  EE_Filter_A		EEMEM;	// Filter des DSP
extern uint8_t  EE_Filter_B		EEMEM;	// Filter des DSP
extern uint8_t 	EE_BAND_A		EEMEM;	// Bandwahl
extern uint8_t 	EE_BAND_B		EEMEM;	// Bandwahl
extern uint8_t  EE_VFO_AB		EEMEM;	// VFO A oder B
extern uint16_t EE_LED_A		EEMEM;	// I2C LED Status
extern uint16_t EE_LED_B		EEMEM;	// I2C LED Status
extern uint32_t EE_ATT_A		EEMEM;	// Attenuator fr VFO A
extern uint32_t EE_ATT_B		EEMEM;	// Attenuator fr VFO B
extern uint32_t EE_freq_160_A	EEMEM;	// letzte Frequenz im 160m Band
extern uint32_t EE_freq_80_A	EEMEM;	// letzte Frequenz im 80m Band
extern uint32_t EE_freq_40_A	EEMEM;	// letzte Frequenz im 40m Band
extern uint32_t EE_freq_30_A	EEMEM;	// letzte Frequenz im 30m Band
extern uint32_t EE_freq_20_A	EEMEM;	// letzte Frequenz im 20m Band
extern uint32_t EE_freq_17_A	EEMEM;	// letzte Frequenz im 17m Band
extern uint32_t EE_freq_15_A	EEMEM;	// letzte Frequenz im 15m Band
extern uint32_t EE_freq_12_A	EEMEM;	// letzte Frequenz im 12m Band
extern uint32_t EE_freq_10_A	EEMEM;	// letzte Frequenz im 10m Band
extern uint32_t EE_freq_6_A		EEMEM;	// letzte Frequenz im 6m Band

extern uint32_t EE_MODE_160_A	EEMEM;		// letzter Mode im 160m Band
extern uint32_t EE_MODE_80_A	EEMEM;		// letzter Mode im 80m Band
extern uint32_t EE_MODE_40_A	EEMEM;		// letzter Mode im 40m Band
extern uint32_t EE_MODE_30_A	EEMEM;		// letzter Mode im 30m Band
extern uint32_t EE_MODE_20_A	EEMEM;		// letzter Mode im 20m Band
extern uint32_t EE_MODE_17_A	EEMEM;		// letzter Mode im 17m Band
extern uint32_t EE_MODE_15_A	EEMEM;		// letzter Mode im 15m Band
extern uint32_t EE_MODE_12_A	EEMEM;		// letzter Mode im 12m Band
extern uint32_t EE_MODE_10_A	EEMEM;		// letzter Mode im 10m Band
extern uint32_t EE_MODE_6_A		EEMEM;		// letzter Mode im 6m Band

extern uint32_t EE_MODE_160_B	EEMEM;		// letzter Mode im 160m Band
extern uint32_t EE_MODE_80_B	EEMEM;		// letzter Mode im 80m Band
extern uint32_t EE_MODE_40_B	EEMEM;		// letzter Mode im 40m Band
extern uint32_t EE_MODE_30_B	EEMEM;		// letzter Mode im 30m Band
extern uint32_t EE_MODE_20_B	EEMEM;		// letzter Mode im 20m Band
extern uint32_t EE_MODE_17_B	EEMEM;		// letzter Mode im 17m Band
extern uint32_t EE_MODE_15_B	EEMEM;		// letzter Mode im 15m Band
extern uint32_t EE_MODE_12_B	EEMEM;		// letzter Mode im 12m Band
extern uint32_t EE_MODE_10_B	EEMEM;		// letzter Mode im 10m Band
extern uint32_t EE_MODE_6_B		EEMEM;		// letzter Mode im 6m Band

extern uint32_t freq_hz;					// speichert die Frequenz in Hz
extern uint32_t freq_temp;					// speichert die Frequenz in Hz

extern struct BitVariablen{
    int menu_aktiv		:1;					// ein Men ist aktiviert
	int freq_input  	:1;					// Frequenzeingabe via 10er Tastatur aktiviert
	int	freq_update 	:1;					// 
	int freq_update_lcd	:1;					// auf dem LCD Frequenz aktualisieren
	int tx_on			:1;					// Sender eingeschaltet
	int ptt_schalten	:1;					// PTT umgeschaltet
	int rit_aktiv		:1;					// RIT Funktion aktiv
}bitvar;

///////////////////////////////////////////////////////////////////////////////
//
//	Frequenzanzeige, der uint32 Wert wird in ein array umgewandelt
//
///////////////////////////////////////////////////////////////////////////////
void Frequenz_to_Array (uint32_t freq_in)
{
	ultoa((long)freq_in, (char*)frequenz, 10);	// konvertiere Long nach Array
	if (freq_in < 10000000)				// kleiner als 10 MHz = eine Stelle weniger
	{
		frequenz[9] = 0;
		frequenz[8] = frequenz[6];
		frequenz[7] = frequenz[5];
		frequenz[6] = frequenz[4];
		frequenz[5] = ',';
		frequenz[4] = frequenz[3];
		frequenz[3] = frequenz[2];
		frequenz[2] = frequenz[1];
		frequenz[1] = '.';
	}
	else								// grer als 10 MHZ
	{
		frequenz[10] = 0;
		frequenz[9] = frequenz[7];
		frequenz[8] = frequenz[6];
		frequenz[7] = frequenz[5];
		frequenz[6] = ',';
		frequenz[5] = frequenz[4];
		frequenz[4] = frequenz[3];
		frequenz[3] = frequenz[2];
		frequenz[2] = '.';
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//	Display neu schreiben
//
///////////////////////////////////////////////////////////////////////////////
void start_menu (void)
{
	uint8_t temp, band = 0;
	lcd_clrscr();							// lsche alles
	Frequenz_to_Array(freq_hz);				// wandel unint32 nach array
	lcd_gotoxy(3,1);
	if (freq_hz < 10000000)					// ist frequenz kleiner als 10 MHz?
	{
		lcd_puts(" ");
	}
	lcd_puts((char*)&frequenz);				// ausgeben auf LCD
	convertDDS(freq_hz);					// Ausgabe der Frequenz zum DDS
	lcd_gotoxy(14, 1); lcd_puts("kHz");
	lcd_gotoxy(6,3);
	if (vfo == 0x00)						// VFO A
	{
		band = band_a;
		lcd_puts("VFO A");
	}
	else									// VFO B
	{
		band = band_b;
		lcd_puts("VFO B");
	}
	temp = load_mode(band, vfo);			// lade aktuellen Mode
	if (mode != temp)
	{
		mode = temp;
		Init_DSP(mode, vfo);				// Mode einstellen
	}	
	lcd_gotoxy(13, 3);
	if (temp == 0x11)
		lcd_puts("LSB SSB");
	else if (temp == 0x12)
		lcd_puts("LSB CW7");
	else if (temp == 0x13)
		lcd_puts("LSB CW8");
	else if (temp == 0x14)
		lcd_puts("LSB CW+");
	else if (temp == 0x21)
		lcd_puts("USB SSB");
	else if (temp == 0x22)
		lcd_puts("USB CW7");
	else if (temp == 0x23)
		lcd_puts("USB CW8");
	else if (temp == 0x24)
		lcd_puts("USB CW+");
	else 
		lcd_puts("na     ");

	lcd_gotoxy(0, 3);						// schreibe das Band
	Rx_Relais &= 0xC00; Tx_Relais = 0;		// die Bnder lschen, nur den ATT behalten
	if (band == 0x01)						// 160m
		{
			lcd_puts("160m");
			Rx_Relais |= Rx_160m;
			Tx_Relais |= Tx_160m;
		}
	else if (band == 0x02)					// 80m
		{
			lcd_puts(" 80m"); 
			Rx_Relais |= Rx_80m; 
			Tx_Relais |= Tx_80m;
		}
	else if (band == 0x03)					// 40m
		{
			lcd_puts(" 40m"); 
			Rx_Relais |= Rx_40m; 
			Tx_Relais |= Tx_40m;
		}
	else if (band == 0x04)					// 30m
		{
			lcd_puts(" 30m"); 
			Rx_Relais |= Rx_30m; 
			Tx_Relais |= Tx_30m;
		}
	else if (band == 0x05)					// 20m
		{
			lcd_puts(" 20m"); 
			Rx_Relais |= Rx_20m; 
			Tx_Relais |= Tx_20m;
		}
	else if (band == 0x06)					// 17m
		{
			lcd_puts(" 17m"); 
			Rx_Relais |= Rx_17m; 
			Tx_Relais |= Tx_17m;
		}
	else if (band == 0x07)					// 15m
		{
			lcd_puts(" 15m"); 
			Rx_Relais |= Rx_15m; 
			Tx_Relais |= Tx_15m;
		}
	else if (band == 0x08)					// 12m
		{
			lcd_puts(" 12m"); 
			Rx_Relais |= Rx_12m; 
			Tx_Relais |= Tx_12m;
		}
	else if (band == 0x09)					// 10m
		{
			lcd_puts(" 10m"); 
			Rx_Relais |= Rx_10m; 
			Tx_Relais |= Tx_10m;
		}
	else if (band == 0x0A)					// 6m
		{
			lcd_puts("  6m"); 
			Tx_Relais |= Tx_6m;
			Rx_Relais |= Rx_6m; 
		}
	lcd_gotoxy(0, 2);						// Zeile 3 am Anfang
	lcd_puts("Ant ");
	temp = ant & 0x0F;						// nur Rx Antenne auswerten
	if (temp == 0x01)
	{
		lcd_puts("1");
		Tx_Relais |= 0x0180;
	}
	else if (temp == 0x02)
	{
		lcd_puts("2");
		Tx_Relais |= 0x0140;
	}
	else if (temp == 0x03)
	{
		lcd_puts ("3");
		Tx_Relais |= 0x00C0;
	}
//	display_RIT();
	LED_onoff(Rx);							// Relais via I2C setzen
	LED_onoff(Tx);							// Relais via I2C setzen
}


///////////////////////////////////////////////////////////////////////////////
//
//	Hintergrundbeleuchtung einstellen
//
///////////////////////////////////////////////////////////////////////////////

void M_DISP_HELL(uint8_t key, uint8_t draw)
{
	if(draw)
	{
		lcd_clrscr();
		lcd_puts("Displayhelligkeit");
		lcd_gotoxy(0,1);
		lcd_puts("einstellbar von 0-9");
		draw = 0; 
		key = 0;
		menu_nr = 101;				// Men Hintergrundbeleuchtung Helligkeit
		lcd_gotoxy(0,3);
		lcd_puts("Stufe: ");
		switch (OCR1A)				// anzeige der momentanen Helligkeit
		{
			case 0:
				lcd_puts("9");
			break;
			case 57:
				lcd_puts("8");
			break;
			case 114:
				lcd_puts("7");
			break;
			case 170:
				lcd_puts("6");
			break;
			case 227:
				lcd_puts("5");
			break;
			case 284:
				lcd_puts("4");
			break;
			case 341:
				lcd_puts("3");
			break;
			case 397:
				lcd_puts("2");
			break;
			case 454:
				lcd_puts("1");
			break;
			case 511:
				lcd_puts("0");
			break;
			default:
				lcd_puts("PWM FEHLER");
			break;
		}
	}
	lcd_gotoxy(7,3);
	switch (key)
	{
		case 23:		// Taste 9
			OCR1A =   0;// hell
			lcd_puts("9");
			break;
		case 18:		// Taste 8
			OCR1A = 57;
			lcd_puts("8");
			break;
		case 13:		// Taste 7
			OCR1A = 114;
			lcd_puts("7");
			break;
		case 24:		// Taste 6
			OCR1A = 170;
			lcd_puts("6");
			break;
		case 19:		// Taste 5
			OCR1A = 227;
			lcd_puts("5");
			break;
		case 14:		// Taste 4
			OCR1A = 284;
			lcd_puts("4");
			break;
		case 25:		// Taste 3
			OCR1A = 341;
			lcd_puts("3");
			break;
		case 20:		// Taste 2
			OCR1A = 397;
			lcd_puts("2");
			break;
		case 15:		// Taste 1
			OCR1A = 454;
			lcd_puts("1");
			break;
		case 17: 		// Taste 0
			OCR1A = 511;// dunkel
			lcd_puts("0");
			break;
		case 12:		// CANCEL
			key = 0;
			OCR1A = eeprom_read_word(&LCD_PWM);
			EINSTELLUNGEN(key, 1);			// bergeordnetes Men anzeigen
			break;
		case 22:		// OK
			bitvar.menu_aktiv = 0;
			key = 0;
			menu_nr = 0;
			draw = 1;
		    eeprom_write_word(&LCD_PWM, OCR1A); // Wert ins EEPROM schreiben
			start_menu();
			break;
		default:
			key = 0;
			break;
	}
	key = 0;
}


///////////////////////////////////////////////////////////////////////////////
//
//	Tastenquittingston ein/aus
//
///////////////////////////////////////////////////////////////////////////////

void M_TASTENTON(uint8_t key, uint8_t draw)
{
	if(draw)
	{ 
		lcd_clrscr();
		lcd_puts("Tastenton ");
		lcd_gotoxy(10, 0);			// anzeigen ob an oder aus
		if (eeprom_read_byte(&Tastenton) == 1)
			lcd_puts("an ");
		else
			lcd_puts("aus");
		lcd_gotoxy(0,2); lcd_puts("1 = Tastenton an");
		lcd_gotoxy(0,3); lcd_puts("0 = Tastenton aus");
		draw = 0; 
		key = 0;
		menu_nr = 102;				// Men Tastenpiep
	}
	switch (key)
	{
		case 17:					// Taste 0
			beep_on_off = 0;		// Tastenton aus
			lcd_gotoxy(10,0);
			lcd_puts("aus");
			break;
		case 15: 					// Taste 1
			beep_on_off = 1;		// Tastenton an
			lcd_gotoxy(10,0);
			lcd_puts("an ");
			break;
		case 12:					// CANCEL
			beep_on_off = eeprom_read_byte(&Tastenton);
			EINSTELLUNGEN(key, 1);// bergeordnetes Men anzeigen
			break;
		case 22:					// OK
			bitvar.menu_aktiv = 0;
			menu_nr = 0;
			draw = 1;
		    eeprom_write_byte(&Tastenton, beep_on_off); // Wert ins EEPROM schreiben
			start_menu();
			break;
		default:
			key = 0;
			break;
	}
	key = 0;
}

///////////////////////////////////////////////////////////////////////////////
//
//	AGC ein- oder ausschalten
//
//////////////////////////////////////////////////////////////////////////////
void M_AGC(uint8_t key, uint8_t draw)
{
	uint8_t agc_var = 0;
	if (draw)
	{
		if (vfo == 0x00)										// VFO A
			agc_var = eeprom_read_byte((uint8_t*)&EE_AGC_A);
		else													// VFO B
			agc_var = eeprom_read_byte((uint8_t*)&EE_AGC_B);
		lcd_clrscr();
		lcd_puts("AGC ");
		lcd_gotoxy(4, 0);									// anzeigen ob an oder aus
		if (agc_var == 0x01)
			lcd_puts("an ");
		else 
			lcd_puts("aus");
		lcd_gotoxy(0,2); lcd_puts("1 = AGC an");
		lcd_gotoxy(0,3); lcd_puts("0 = AGC aus");
		menu_nr = 104;										// Men AGC
	}
	switch (key)
	{
		case 17:											// Taste 0
			if (AGC == 1)									// AGC war an
			{
				lcd_gotoxy(4,0);
				lcd_puts("aus");
				leds &= AGC_LED_aus;						// Led fr AGC aus
				LED_onoff(Front_LED);						// I2C Ausgnge schalten
				AGC = 0;
				Filter_res = 0;	_delay_ms(1); Filter_res = 1;// Reset zum neuladen der Koeffizienten
			}
			break;
		case 15: 											// Taste 1
			if (AGC == 0)									// AGC war aus
			{
				lcd_gotoxy(4,0);
				lcd_puts("an ");
				leds |= AGC_LED_an;							// Led fr AGC an
				LED_onoff(Front_LED);						// I2C Ausgnge schalten
				AGC = 1;
				Filter_res = 0;	_delay_ms(1); Filter_res = 1;// Reset zum neuladen der Koeffizienten
			}
			break;
		case 12:											// CANCEL
			if (vfo == 0x00)								// VFO A
				AGC = eeprom_read_byte((uint8_t*)&EE_AGC_A);
			else											// VFO B
				AGC = eeprom_read_byte((uint8_t*)&EE_AGC_B);
			Filter_res = 0;	_delay_ms(1); Filter_res = 1;	// Reset zum neuladen der Koeffizienten
			EINSTELLUNGEN(key, 1);							// bergeordnetes Men anzeigen
			break;
		case 22:											// OK
			bitvar.menu_aktiv = 0;
			menu_nr = 0;
			draw = 1;
			if (vfo == 0x00)								// VFO A
				eeprom_write_byte(&EE_AGC_A, AGC); 			// Wert ins EEPROM schreiben
			else											// VFO B
				eeprom_write_byte(&EE_AGC_B, AGC);	 		// Wert ins EEPROM schreiben
			start_menu();
			break;
		default:
			key = 0;
			break;
	}
	key = 0;
}


///////////////////////////////////////////////////////////////////////////////
//
//	Schrittweite fr den Encoder
//
///////////////////////////////////////////////////////////////////////////////
void M_SCHRITTWEITE(uint8_t key, uint8_t draw)
{
	if(draw)
	{ 
		lcd_clrscr();
		lcd_puts("Schrittweite ");
		lcd_gotoxy(13, 0);			// anzeigen ob an oder aus
		step = eeprom_read_byte(&Schrittweite);
		if (step == 1)
			lcd_puts("1 Hz   ");
		else if (step == 2)
			lcd_puts("10 Hz  ");
		else if (step == 3)
			lcd_puts("50 Hz  ");
		else if (step == 4)
			lcd_puts("100 Hz ");
		else if (step == 5)
			lcd_puts("500 Hz ");
		else if (step == 6)
			lcd_puts("1000 Hz");
		else 
			lcd_puts("na");
		lcd_gotoxy(0,1); lcd_puts("1 = 1 Hz  4 = 100 Hz");
		lcd_gotoxy(0,2); lcd_puts("2 = 10 Hz 5 = 500 Hz");
		lcd_gotoxy(0,3); lcd_puts("3 = 50 Hz 6 = 1 kHz ");
		draw = 0; 
		key = 0;
		menu_nr = 103;				// Men Schrittweite
	}
	switch (key)
	{
		case 15:					// Taste 1
			step = 1;				// Schrittweite = 1 Hz
			lcd_gotoxy(13,0);
			lcd_puts("1 Hz   ");
			break;
		case 20: 					// Taste 2
			step = 2;				// Schrittweite = 10 Hz
			lcd_gotoxy(13,0);
			lcd_puts("10 Hz  ");
			break;
		case 25: 					// Taste 3
			step = 3;				// Schrittweite = 50 Hz
			lcd_gotoxy(13,0);
			lcd_puts("50 Hz  ");
			break;
		case 14:					// Taste 4
			step = 4;				// Schrittweite = 100 Hz
			lcd_gotoxy(13,0);
			lcd_puts("100 Hz ");
			break;
		case 19:					// Taste 5
			step = 5;				// Schrittweite = 500 Hz
			lcd_gotoxy(13,0);
			lcd_puts("500 Hz ");
			break;
		case 24:					// Taste 6
			step = 6;				// Schrittweite = 1 KHz
			lcd_gotoxy(13,0);
			lcd_puts("1 kHz  ");
			break;
		case 12:					// CANCEL
			step = eeprom_read_byte(&Schrittweite);
			EINSTELLUNGEN(key, 1);	// bergeordnetes Men anzeigen
			break;
		case 22:					// OK
			bitvar.menu_aktiv = 0;
			menu_nr = 0;
			draw = 1;
		    eeprom_write_byte(&Schrittweite, step); // Wert ins EEPROM schreiben
			start_menu();
			break;
		default:
			key = 0;
			break;
	}
	key = 0;
}

///////////////////////////////////////////////////////////////////////////////
//
//	Empfngereinstellungen fr Rx Antenne
//	- die Antennenrelais sind low aktiv, 1 = Antenne auf Masse, 0 = Antenne zum Rx
//
///////////////////////////////////////////////////////////////////////////////

void M_RX(uint8_t key, uint8_t draw)
{
	uint8_t temp = 0, band = 0;
	if(draw)
	{ 
		lcd_clrscr();
		lcd_puts("Empf");lcd_data(0xe1);lcd_puts("ngerantenne");
		lcd_gotoxy(17, 0);			// anzeigen welche Antenne gewhlt
		if (vfo == 0x00)			// VFO A
			band = band_a;	
		else						// VFO B
			band = band_b;	
		ant = load_ant(band);		// aktuelle Antenneneinstellung laden
		temp = ant & 0x0F;			// nur Rx Antenne auswerten
		if (temp == 0x01)
			lcd_puts("1");
		else if (temp == 0x02)
			lcd_puts("2");
		else if (temp == 0x03)
			lcd_puts ("3");
		lcd_gotoxy(0,1); lcd_puts("1 = Antenne 1");
		lcd_gotoxy(0,2); lcd_puts("2 = Antenne 2");
		lcd_gotoxy(0,3); lcd_puts("3 = Antenne 3");
		draw = 0; 
		key = 0;
		menu_nr = 301;				// Men Antennenrelais Rx
	}
	switch (key)
	{
		case 15:					// Taste 1
			Tx_Relais |= (Ant1_aus | Ant2_aus | Ant3_aus);	// die Antennenrelais lschen, alle auf '1' setzen
			Tx_Relais &= Ant1_an;
			ant &= 0xF0;			// nur Rx Antenne auswerten
			ant |= 0x01;			// Antenne 1 setzen
			lcd_gotoxy(17,0);
			lcd_puts("1");
			break;
		case 20: 					// Taste 2
			Tx_Relais |= (Ant1_aus | Ant2_aus | Ant3_aus);	// die Antennenrelais lschen, alle auf '1' setzen
			Tx_Relais &= Ant2_an;
			ant &= 0xF0;			// nur Rx Antenne auswerten
			ant |= 0x02;			// Antenne 2 setzen
			lcd_gotoxy(17,0);
			lcd_puts("2");
			break;
		case 25: 					// Taste 3
			Tx_Relais |= (Ant1_aus | Ant2_aus | Ant3_aus);	// die Antennenrelais lschen, alle auf '1' setzen
			Tx_Relais &= Ant3_an;
			ant &= 0xF0;			// nur Rx Antenne auswerten
			ant |= 0x03;			// Antenne 3 setzen
			lcd_gotoxy(17,0);
			lcd_puts("3");
			break;
		case 12:					// CANCEL
			Tx_Relais |= (Ant1_aus | Ant2_aus | Ant3_aus);	// die Antennenrelais lschen, alle auf '1' setzen
			if (vfo == 0x00)			// VFO A
				band = band_a;	
			else						// VFO B
				band = band_b;	
			ant = load_ant(band);		// aktuelle Antenneneinstellung laden
			temp = ant & 0x0F;
			if (temp == 0x01)
				Tx_Relais &= Ant1_an;
			else if (temp == 0x02)
				Tx_Relais &= Ant2_an;
			else if (temp == 0x03)
				Tx_Relais &= Ant3_an;
			M_ANT(key, 1);			// bergeordnetes Men anzeigen
			break;
		case 22:					// OK
			bitvar.menu_aktiv = 0;
			menu_nr = 0;
			draw = 1;
			if (vfo == 0x00)		// VFO A
				band = band_a;
			else					// VFO B
				band = band_b;		    
			save_ant(band, ant);	// die Antenneneinstellung speichern
			start_menu();
			break;
		default:
			key = 0;
			break;
	}
	key = 0;
	LED_onoff(Tx);					// Relais via I2C setzen
}

///////////////////////////////////////////////////////////////////////////////
//
//	Empfngereinstellungen fr Tx Antenne
//
///////////////////////////////////////////////////////////////////////////////
void M_TX(uint8_t key, uint8_t draw)
{
	uint8_t temp = 0, band = 0;
	if(draw)
	{ 
		lcd_clrscr();
		lcd_puts("Sendeantenne ");
		lcd_gotoxy(13, 0);			// anzeigen welche Antenne gewhlt
		if (vfo == 0x00)			// VFO A
			band = band_a;	
		else						// VFO B
			band = band_b;	
		ant = load_ant(band);		// aktuelle Antenneneinstellung laden
		temp = ant & 0xF0;			// nur Tx Antenne auswerten
		if (temp == 0x10)
			lcd_puts("1");
		else if (temp == 0x20)
			lcd_puts("2");
		else if (temp == 0x30)
			lcd_puts ("3");
		lcd_gotoxy(0,1); lcd_puts("1 = Antenne 1");
		lcd_gotoxy(0,2); lcd_puts("2 = Antenne 2");
		lcd_gotoxy(0,3); lcd_puts("3 = Antenne 3");
		draw = 0; 
		key = 0;
		menu_nr = 302;				// Men Antennenwahl Tx
	}
	switch (key)
	{
		case 15:					// Taste 1
			ant &= 0x0F;			// nur Tx Antenne auswerten
			ant |= 0x10;
			lcd_gotoxy(13,0);
			lcd_puts("1");
			break;
		case 20: 					// Taste 2
			ant &= 0x0F;			// nur Tx Antenne auswerten
			ant |= 0x20;
			lcd_gotoxy(13,0);
			lcd_puts("2");
			break;
		case 25: 					// Taste 3
			ant &= 0x0F;			// nur Tx Antenne auswerten
			ant |= 0x30;
			lcd_gotoxy(13,0);
			lcd_puts("3");
			break;
		case 12:					// CANCEL
			if (vfo == 0x00)		// VFO A
				band = band_a;	
			else					// VFO B
				band = band_b;	
			ant = load_ant(band);	// aktuelle Antenneneinstellung laden
			M_ANT(key, 1);			// bergeordnetes Men anzeigen
			break;
		case 22:					// OK
			bitvar.menu_aktiv = 0;
			menu_nr = 0;
			draw = 1;
			if (vfo == 0x00)		// VFO A
				band = band_a;
			else					// VFO B
				band = band_b;		    
			save_ant(band, ant);	// die Antenneneinstellung speichern
			start_menu();
			break;
		default:
			key = 0;
			break;
	}
	key = 0;
}

///////////////////////////////////////////////////////////////////////////////
//
//	Kurzer Quittierungston fr Tasteneingabe
//
///////////////////////////////////////////////////////////////////////////////
void key_beep_short(void)
{
	if (beep_on_off == 1)
	{
		PORTG |= (1<<2); // Summer an
		_delay_ms(2);
		PORTG &= ~(1<<2);// Summer aus
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//	Langer Quittierungston fr richtige Eingabe
//
///////////////////////////////////////////////////////////////////////////////
void key_beep_long(void)
{
	if (beep_on_off == 1)
	{
		PORTG |= (1<<2); // Summer an
		_delay_ms(100);
		PORTG &= ~(1<<2);// Summer aus
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//	Modus ndern (LSB, USB, CW, CW+9
//
///////////////////////////////////////////////////////////////////////////////
void Mode(uint8_t key, uint8_t draw)
{
	uint8_t band;
	bitvar.menu_aktiv = 1;
	key_beep_short();
	if(draw)
	{
		lcd_clrscr();
		lcd_puts("Betriebsart: ");
		lcd_gotoxy(0,1); lcd_puts("1: LSB    2: USB   ");
		lcd_gotoxy(0,2); lcd_puts("3: SSB    4: CW 700");
		lcd_gotoxy(0,3); lcd_puts("5: CW 800 6: CW +  ");
		lcd_gotoxy(12,0);
		key = 0;
		draw = 0;
		if (vfo == 0x00)						// VFO A
			band = band_a;
		else									// VFO B
			band = band_b;

		mode = load_mode(band, vfo);			// lade aktuellen Mode
		if (mode == 0x11)
			lcd_puts("LSB  SSB");
		else if (mode == 0x12)
			lcd_puts("LSB  CW7");
		else if (mode == 0x13)
			lcd_puts("LSB  CW8");
		else if (mode == 0x14)
			lcd_puts("LSB  CW+");
		else if (mode == 0x21)
			lcd_puts("USB  SSB");
		else if (mode == 0x22)
			lcd_puts("USB  CW7");
		else if (mode == 0x23)
			lcd_puts("USB  CW8");
		else if (mode == 0x24)
			lcd_puts("USB  CW+");
		else 
			lcd_puts("na     ");
		draw = 0; 
		key = 0;
		menu_nr = 200;							// Men Betriebsart
	}
	switch (key)
	{
		case 15:								// Taste 1
			mode_temp = ((mode & 0x0F) | 0x10);	// LSB
			if (mode == mode_temp)
				break;
			lcd_gotoxy(12,0);
			lcd_puts("LSB");
			Init_DSP(mode_temp, vfo);			// Initialisiere DSP
			mode = mode_temp;
			break;
		case 20: 								// Taste 2
			mode_temp = ((mode & 0x0F) | 0x20);	// USB
			if (mode == mode_temp)
				break;
			lcd_gotoxy(12,0);
			lcd_puts("USB");
			Init_DSP(mode_temp, vfo);			// Initialisiere DSP
			mode = mode_temp;
			break;
		case 25: 								// Taste 3
			mode_temp = ((mode & 0xF0) | 0x01);	// SSB
			if (mode == mode_temp)
				break;
			lcd_gotoxy(17,0);
			lcd_puts("SSB");
			Init_DSP(mode_temp, vfo);			// Initialisiere DSP
			mode = mode_temp;
			break;
		case 14:								// Taste 4
			mode_temp = ((mode & 0xF0) | 0x02);	// CW 700 Hz
			if (mode == mode_temp)
				break;
			lcd_gotoxy(17,0);
			lcd_puts("CW7");
			Init_DSP(mode_temp, vfo);				// Initialisiere DSP
			mode = mode_temp;
			break;
		case 19:								// Taste 5
			mode_temp = ((mode & 0xF0) | 0x03);	// CW 800 Hz
			if (mode == mode_temp)
				break;
			lcd_gotoxy(17,0);
			lcd_puts("CW8");
			Init_DSP(mode_temp, vfo);			// Initialisiere DSP
			mode = mode_temp;
			break;
		case 24:								// Taste 6
			mode_temp = ((mode & 0xF0) | 0x04);	// CW +
			if (mode == mode_temp)
				break;
			lcd_gotoxy(17,0);
			lcd_puts("CW+");
			Init_DSP(mode_temp, vfo);			// Initialisiere DSP
			mode = mode_temp;
			break;
		case 12:								// CANCEL
			bitvar.menu_aktiv = 0;
			menu_nr = 0;
			draw = 1;
			start_menu();
			break;
		case 22:								// OK
			bitvar.menu_aktiv = 0;
			menu_nr = 0;
			draw = 1;
			if (vfo == 0x00)					// VFO A
				band = band_a;
			else								// VFO B
				band = band_b;
			save_mode(mode, vfo, band);			// speichere aktuellen Mode
			start_menu();
			break;
		default:
			key = 0;
			break;
	}
	key = 0;
}


///////////////////////////////////////////////////////////////////////////////
//
//	Hauptmen
//
///////////////////////////////////////////////////////////////////////////////
void MENUE_HAUPT(uint8_t key, uint8_t draw)					// Hauptmen nach "21" Men
{
	bitvar.menu_aktiv = 1;
	if(draw)
	{
		lcd_clrscr();
		lcd_puts("1: Einstellungen");
		lcd_gotoxy(0,1); lcd_puts("2: Antennenwahl");
		lcd_gotoxy(0,2); lcd_puts("3: auch leer");
		lcd_gotoxy(0,3); lcd_puts("4: immer noch leer");
		key = 0;
		draw = 0;
	}
	if ((key == 22) || (key == 12))		// Tastenton
		key_beep_long();
	else
		key_beep_short();
	if (menu_nr == 0)
	{
		switch (key)
		{
			case 15: 		// Taste 1
				draw = 1;	// neues Men anzeigen
				EINSTELLUNGEN(key, 1);// PWM Men aufrufen
				break;
			case 20:		// Taste 2
				draw = 1;	// Empfnger Men anzeigen
				M_ANT(key, 1);
				break;
			case 25:		// Taste 3
				draw = 1;	// neues Men anzeigen
				break;
			case 14:		// Taste 4
				draw = 1;	// neues Men anzeigen
				break;
			case 12:		// CANCEL
				bitvar.menu_aktiv = 0;
				start_menu();
				key = 0;
				menu_nr = 0;
				draw = 1;
				break;
			case 22:		// OK
				bitvar.menu_aktiv = 0;
				start_menu();
				key = 0;
				menu_nr = 0;
				draw = 1;
				break;
			default:
				key = 0;
				break;
		}
	}
	else
	{
		switch (menu_nr)
		{
			case 100:
				EINSTELLUNGEN(key, draw);
			break;
				case 101:
					M_DISP_HELL(key, draw);
					break;
				case 102:
					M_TASTENTON(key, draw);
					break;
				case 103:
					M_SCHRITTWEITE(key, draw);
					break;
				case 104:
					M_AGC(key, draw);
					break;
				case 200:
					Mode(key, draw);
					break;
				case 300:
					M_ANT(key, draw);
					break;
				case 301:
					M_RX(key, draw);
					break;
				case 302:
					M_TX(key, draw);
					break;
			default:

			break;
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
//
//	Antennenwahl
//
///////////////////////////////////////////////////////////////////////////////
void M_ANT(uint8_t key, uint8_t draw)
{ 
	if(draw)
	{ 
		lcd_clrscr();	 lcd_puts("1: Empf");lcd_data(0xe1);lcd_puts("ngerantenne");
		lcd_gotoxy(0,1); lcd_puts("2: Senderantenne");
		key = 0;
		draw = 0;
		menu_nr = 300;	// Men Antennenwahl
	}
	switch (key)
	{
		case 15: 		// Taste 1
			draw = 1;
			M_RX(key, draw);			// Rx Antenne
			break;
		case 20:		// Taste 2
			draw = 1;
			M_TX(key, draw);			// Tx Antenne
			break;
		case 25:		// Taste 3
			break;
		case 14:		// Taste 4
			break;
		case 12:		// Back
			key = 0;
			menu_nr = 0;
			MENUE_HAUPT(0, 1);
			break;
		case 22:		// OK
			bitvar.menu_aktiv = 0;
			start_menu();
			key = 0;
			menu_nr = 0;
			draw = 1;
			break;
		default:
			key = 0;
			break;
	}
	key = 0;
}


///////////////////////////////////////////////////////////////////////////////
//
//	Einstellungsmen
//
///////////////////////////////////////////////////////////////////////////////
void EINSTELLUNGEN(uint8_t key, uint8_t draw)
{ 
	if(draw)
	{ 
		lcd_clrscr();	 lcd_puts("1: Disp. Helligkeit");
		lcd_gotoxy(0,1); lcd_puts("2: Tastenton");
		lcd_gotoxy(0,2); lcd_puts("3: Schrittweite");
		lcd_gotoxy(0,3); lcd_puts("4: AGC");
		key = 0;
		draw = 0;
		menu_nr = 100;	// Men Einstellungen
	}
	switch (key)
	{
		case 15: 		// Taste 1
			draw = 1;
			M_DISP_HELL(key, draw);			// Display Helligkeit
			break;
		case 20:		// Taste 2
			draw = 1;
			M_TASTENTON(key, draw);			// Tastenton
			break;
		case 25:		// Taste 3
			draw = 1;
			M_SCHRITTWEITE(key, draw);		// Encoder Schrittweite
			break;
		case 14:		// Taste 4
			draw = 1;
			M_AGC(key, draw);				// AGC ein/aus
			break;
		case 12:		// Back
			key = 0;
			menu_nr = 0;
			MENUE_HAUPT(0, 1);
			break;
		case 22:		// OK
			bitvar.menu_aktiv = 0;
			start_menu();
			key = 0;
			menu_nr = 0;
			draw = 1;
			break;
		default:
			key = 0;
			break;
	}
	key = 0;
}

///////////////////////////////////////////////////////////////////////////////
//
//	Quittierungston fr Fehleingabe
//
///////////////////////////////////////////////////////////////////////////////
void key_beep_error(void)
{
	if (beep_on_off == 1)
	{
		PORTG |= (1<<2); // Summer an
		_delay_ms(50);
		PORTG &= ~(1<<2);// Summer aus
		_delay_ms(100);
		PORTG |= (1<<2); // Summer an
		_delay_ms(50);
		PORTG &= ~(1<<2);// Summer aus
		_delay_ms(100);
		PORTG |= (1<<2); // Summer an
		_delay_ms(50);
		PORTG &= ~(1<<2);// Summer aus
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//	Tasteneingabe und berprfung auf Bereichsberschreitung 
//	gltiger Bereich von 1 MHz - 52 MHz
//
///////////////////////////////////////////////////////////////////////////////
void frequenz_eingabe(uint8_t key)
{
	uint8_t i, x, redraw = 1, band = 0;
	uint32_t freq_temp;
	uint32_t attenuator = 0;
	if (!(leds & Lock_LED_an))						// ist das bit gelscht?
	{
		bitvar.freq_input = 1;					// Frequenzeingabe aktiv
		lcd_gotoxy(3,1);						// Startposition zum schreiben
		if (stelle == 0)						// Display lschen nur bei Frequenzeingabe
		{
			if ((key != 22) && (key != 12))		// Ziffer gedrckt
				for (i = 0; i < 10; i++)		// lsche alle alten Ziffern
				{
					lcd_puts(" ");
				}
			else 								// OK oder CANCEL als erste Taste gedrckt
			{
				bitvar.freq_input = 0;			// Frequenzeingabe beendet
				return;
			}
		}
		if (stelle == 0)						// lsche die alten Werte
		{
			for (x = 0; x < 10; x++)			// kopiere alte Frequenz in neues Array
			    frequenz_alt[x] = frequenz[x];
			for (x = 0; x < 10; x++)			// lsche array
			    frequenz[x] = 0;
		}
		switch (key)							// decodiere Tasten
		{
			case 15:		// Taste 1
				frequenz[stelle] = '1';
				stelle++;
				break;
			case 20:		// Taste 2
				frequenz[stelle] = '2';
				stelle++;
				break;
			case 25:		// Taste 3
				frequenz[stelle] = '3';
				stelle++;
				break;
			case 14:		// Taste 4
				frequenz[stelle] = '4';
				stelle++;
				break;
			case 19:		// Taste 5
				frequenz[stelle] = '5';
				stelle++;
				break;
			case 24:		// Taste 6
				frequenz[stelle] = '6';
				stelle++;
				break;
			case 13:		// Taste 7
				frequenz[stelle] = '7';
				stelle++;
				break;
			case 18:		// Taste 8
				frequenz[stelle] = '8';
				stelle++;
				break;
			case 23:		// Taste 9
				frequenz[stelle] = '9';
				stelle++;
				break;
			case 17:		// Taste 0
				frequenz[stelle] = '0';
				stelle++;
				break;
			case 12:		// Taste CANCEL
				stelle = 0;
				for (x = 0; x <= 10; x++)		// kopiere alte Frequenz zurck in aktuelle Frequenz
	   				frequenz[x] = frequenz_alt[x];
				key_beep_long();
				bitvar.freq_input = 0;			// Frequenzeingabe beendet
				bitvar.freq_update_lcd = 0;		// LCD Frequenz ndern
				if (freq_hz < 10000000)
				{
					lcd_gotoxy(3,1);
					lcd_puts(" ");
				}
				Frequenz_to_Array(freq_hz);		// umrechnen nach Array
				lcd_puts((char*)&frequenz);		// ausgeben auf LCD CANCEL
				redraw = 0;						// nicht neu schreiben
				key = 0;						
				return;							// Funktion beenden
				break;
			case 22:		// Taste OK
				if ((stelle == 1) && (frequenz[0] == '0')) // OK gedrckt nachdem nur eine Ziffer eingegeben wurde
				{
					for (x = 0; x <= 10; x++)	// kopiere alte Frequenz zurck in aktuelle Frequenz
		   				frequenz[x] = frequenz_alt[x];
					stelle = 0;
					key_beep_error();
					break;
				}
				rit_off();						// eventuelle RIT oder XIT Funktion ausschalten
				for (x = stelle; x <= 9; x++)	// restliche Stellen mit Nullen auffllen
					frequenz[x] = '0';
				frequenz[2] = '.';
				frequenz[6] = ',';
				// umrechnen vom array nach integerzahl, -'0' fr umsetzen von ASCII nach Zahl
				freq_temp = freq_hz;
				freq_hz = 	(frequenz[0] - '0') * 10000000 + (frequenz[1] - '0') * 1000000 + (frequenz[3] - '0') * 100000 + 
						(frequenz[4] - '0') * 10000L + (frequenz[5] - '0') * 1000 + (frequenz[7] - '0') * 100 +
						(frequenz[8] - '0') * 10 + (frequenz[9] - '0');
				// Bandwechsel durch Frequenzeingabe nach OK Taste
				if ((freq_hz >= 1810000) && (freq_hz < 2000000))
				{
					if (vfo == 0x00)
					{
						band_a = 1;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern						
					}
					else
					{
						band_b = 1;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 3500000) && (freq_hz < 3800000))
				{
					if (vfo == 0x00)
					{
						band_a = 2;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 2;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 7000000) && (freq_hz < 7200000))
				{
					if (vfo == 0x00)
					{
						band_a = 3;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 3;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 10100000) && (freq_hz < 10150000))
				{
					if (vfo == 0x00)
					{
						band_a = 4;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 4;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 14000000) && (freq_hz < 14350000))
				{
					if (vfo == 0x00)
					{
						band_a = 5;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 5;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 18068000) && (freq_hz < 18168000))
				{
					if (vfo == 0x00)
					{
						band_a = 6;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 6;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 21000000) && (freq_hz < 21450000))
				{
					if (vfo == 0x00)
					{
						band_a = 7;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 7;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 24890000) && (freq_hz < 24990000))
				{
					if (vfo == 0x00)
					{
						band_a = 8;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 8;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 28000000) && (freq_hz < 29700000))
				{
					if (vfo == 0x00)
					{
						band_a = 9;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 9;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 50080000) && (freq_hz < 52000000))
				{
					if (vfo == 0x00)
					{
						band_a = 10;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 10;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else
				{
					freq_hz = freq_temp;			// alte Frequenz wiederherstellen
					for (x = 0; x <= 10; x++)		// kopiere alte Frequenz zurck in aktuelle Frequenz
		   				frequenz[x] = frequenz_alt[x];
					stelle = 0;						// lsche Zhler
					lcd_gotoxy(3,1);				// alte Frequenz neu aufs Display schreiben
					if (freq_hz < 10000000)			// ist Frequenz kleiner als 10 MHz?
					{
						lcd_puts(" ");
					}
					lcd_puts((char*)&frequenz);		// ausgeben auf LCD (OK)
					key_beep_error();
					bitvar.freq_update = 0;			// Frequenz gendert
					bitvar.freq_input = 0;			// Frequenzeingabe beendet
					redraw = 1;
					return;
				}
				if (vfo == 0x00)
				{
					eeprom_read_block(&attenuator, &EE_ATT_A, sizeof(uint32_t)); // Attenuatorset frs passende Band laden
					Rx_Relais &= 0x3FF; 					// die Att lschen, nur die Bnder behalten
					if (band_a == 0x01)						// 160m
					{
						Rx_Relais |= ((attenuator & 0x03) * 1024);
					}
					else if (band_a == 0x02)				// 80m
					{
						Rx_Relais |= ((attenuator & 0x0C) * 256);
					}
					else if (band_a == 0x03)				// 40m
					{
						Rx_Relais |= ((attenuator & 0x30) * 64);
					}
					else if (band_a == 0x04)				// 30m
					{
						Rx_Relais |= ((attenuator & 0xC0) * 16);
					}
					else if (band_a == 0x05)				// 20m
					{
						Rx_Relais |= ((attenuator & 0x300) * 4);
					}
					else if (band_a == 0x06)				// 17m
					{
						Rx_Relais |= (attenuator & 0xC00);
					}
					else if (band_a == 0x07)				// 15m
					{
						Rx_Relais |= ((attenuator & 0x3000) / 4);
					}
					else if (band_a == 0x08)				// 12m
					{
						Rx_Relais |= ((attenuator & 0xC000) / 16);
					}
					else if (band_a == 0x09)				// 10m
					{
						Rx_Relais |= ((attenuator & 0x30000) / 64);
					}
					else if (band_a == 0x0A)				// 6m
					{
						Rx_Relais |= ((attenuator & 0xC0000) / 256);	
					}
				}
				else
				{
					eeprom_read_block(&attenuator, &EE_ATT_B, sizeof(uint32_t)); // Attenuatorset frs passende Band laden
					Rx_Relais &= 0x3FF; 					// die Att lschen, nur die Bnder behalten
					if (band_b == 0x01)						// 160m
					{
						Rx_Relais |= ((attenuator & 0x03) * 1024);
					}
					else if (band_b == 0x02)				// 80m
					{
						Rx_Relais |= ((attenuator & 0x0C) * 256);
					}
					else if (band_b == 0x03)				// 40m
					{
						Rx_Relais |= ((attenuator & 0x30) * 64);
					}
					else if (band_b == 0x04)				// 30m
					{
						Rx_Relais |= ((attenuator & 0xC0) * 16);
					}
					else if (band_b == 0x05)				// 20m
					{
						Rx_Relais |= ((attenuator & 0x300) * 4);
					}
					else if (band_b == 0x06)				// 17m
					{
						Rx_Relais |= (attenuator & 0xC00);
					}
					else if (band_b == 0x07)				// 15m
					{
						Rx_Relais |= ((attenuator & 0x3000) / 4);
					}
					else if (band_b == 0x08)				// 12m
					{
						Rx_Relais |= ((attenuator & 0xC000) / 16);
					}
					else if (band_b == 0x09)				// 10m
					{
						Rx_Relais |= ((attenuator & 0x30000) / 64);
					}
					else if (band_b == 0x0A)				// 6m
					{
						Rx_Relais |= ((attenuator & 0xC0000) / 256);	
					}
				}
				leds &= ATT_0dB_LED;						// alle LEDs aus
				if ((Rx_Relais & 0xC00) == 0x400)
					leds |= ATT_10dB_LED;
				else if ((Rx_Relais & 0xC00) == 0x800)
					leds |= ATT_20dB_LED;
				else if ((Rx_Relais & 0xC00) == 0xC00)
					leds |= ATT_30dB_LED;
				LED_onoff(Front_LED); LED_onoff(Rx);
//				bitvar.freq_update = 1;			// Frequenz gendert
//				bitvar.freq_update_lcd = 1;		// LCD Frequenz ndern
				redraw = 0;						// Wert nicht nochmal schreiben
				stelle = 0;
				key_beep_long();
				key = 0;
				bitvar.freq_input = 0;			// Frequenzeingabe beendet
				start_menu();
				return;
				break;
			default:
				break;
		}
		if (stelle == 1)						// Frequenzeingabe grer 60 MHz
		{
			if (frequenz[0] >= '6')
			{
				for (x = 0; x < 10; x++)		// kopiere alte Frequenz zurck in aktuelle Frequenz
	       			frequenz[x] = frequenz_alt[x];
				stelle = 0;						// lsche Zhler
				lcd_gotoxy(3, 1);				// aktuell eingegebene Frequenz ausgeben
				if (freq_hz < 10000000)			// ist frequenz kleiner als 10 MHz?
				{
					lcd_puts(" ");
				}			
				lcd_puts((char*)&frequenz);		// ausgeben auf LCD (STELLE 1)
				redraw = 0;						// Wert nicht nochmal schreiben
				key_beep_error();
				bitvar.freq_input = 0;			// Frequenzeingabe beendet
			}
		}
		if (stelle == 2)						// Punkt einfgen bei MHz Trennung und auf Bereichsberschreitung testen
												// 1 MHz - 51.999,999 MHz
		{
			frequenz[stelle] = '.';				// Punkt einfgen
			stelle++;
			if (((frequenz[0] == '0') && (frequenz[1] == '0')) || ((frequenz[0] >= '5') && (frequenz[1] >= '2')))
			// bei Frequenz kleiner als 1 MHz oder grer 51.999,999 MHz
			{
				for (x = 0; x < 10; x++)		// kopiere alte Frequenz zurck in aktuelle Frequenz
	       			frequenz[x] = frequenz_alt[x];
				stelle = 0;						// lsche Zhler
				lcd_gotoxy(3,1);
				if (freq_hz < 10000000)			// ist frequenz kleiner als 10 MHz?
				{
					lcd_puts(" ");
				}
				lcd_puts((char*)&frequenz);		// ausgeben auf LCD (STELLE 2)
				redraw = 0;						// Wert nicht nochmal schreiben
				key_beep_error();
				bitvar.freq_input = 0;			// Frequenzeingabe beendet
			}
		}
		if (stelle == 6)						// Komma einfgen bei kHz Trennung
		{
			frequenz[stelle] = ',';
			stelle++;
		}
		if (redraw == 1)						// nur neu schreiben wenn ntig
		{
			lcd_gotoxy(3, 1);					// aktuell eingegebene Frequenz ausgeben
			lcd_puts((char*)&frequenz);			// ausgeben auf LCD (REDRAW)
			if (frequenz[0] == '0')				// fhrende Null unterdrcken
			{
				lcd_gotoxy(3,1);
				lcd_puts(" ");
			}
			redraw = 0;
		}
		if (stelle == 10)						// alle 8 Stellen eingegeben
		{
			stelle = 0;
			key_beep_long();
			bitvar.freq_input = 0;				// Frequenzeingabe beendet
			// umrechnen vom array nach integerzahl 
			freq_temp = freq_hz;
			freq_hz = 	(frequenz[0] - '0') * 10000000 + (frequenz[1] - '0') * 1000000 + (frequenz[3] - '0') * 100000 + 
					(frequenz[4] - '0') * 10000L + (frequenz[5] - '0') * 1000 + (frequenz[7] - '0') * 100 +
					(frequenz[8] - '0') * 10 + (frequenz[9] - '0');
			bitvar.freq_update = 1;				// Frequenz gendert
			bitvar.freq_update_lcd = 1;			// LCD Frequenz ndern
			// Bandwechsel durch Frequenzeingabe nach Eingabe von 10 Ziffern
				if ((freq_hz >= 1810000) && (freq_hz < 2000000))
				{
					if (vfo == 0x00)
					{
						band_a = 1;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern						
					}
					else
					{
						band_b = 1;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 3500000) && (freq_hz < 3800000))
				{
					if (vfo == 0x00)
					{
						band_a = 2;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 2;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}

					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 7000000) && (freq_hz < 7200000))
				{
					if (vfo == 0x00)
					{
						band_a = 3;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 3;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 10100000) && (freq_hz < 10150000))
				{
					if (vfo == 0x00)
					{
						band_a = 4;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 4;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 14000000) && (freq_hz < 14350000))
				{
					if (vfo == 0x00)
					{
						band_a = 5;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 5;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 18068000) && (freq_hz < 18168000))
				{
					if (vfo == 0x00)
					{
						band_a = 6;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 6;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 21000000) && (freq_hz < 21450000))
				{
					if (vfo == 0x00)
					{
						band_a = 7;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 7;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 24890000) && (freq_hz < 24990000))
				{
					if (vfo == 0x00)
					{
						band_a = 8;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 8;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 28000000) && (freq_hz < 29700000))
				{
					if (vfo == 0x00)
					{
						band_a = 9;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 9;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else if ((freq_hz >= 50080000) && (freq_hz < 52000000))
				{
					if (vfo == 0x00)
					{
						band_a = 10;
						eeprom_write_byte((uint8_t*)&EE_BAND_A, band_a);// das Band im EEPROM speichern	
					}
					else
					{
						band_b = 10;
						eeprom_write_byte((uint8_t*)&EE_BAND_B, band_b);// das Band im EEPROM speichern	
					}
					save_band(freq_hz);							// die Frequenz vom alten Band speichern
				}
				else
				{
					freq_hz = freq_temp;			// alte Frequenz wiederherstellen
					for (x = 0; x <= 10; x++)		// kopiere alte Frequenz zurck in aktuelle Frequenz
		   				frequenz[x] = frequenz_alt[x];
					stelle = 0;						// lsche Zhler
					lcd_gotoxy(3,1);				// alte Frequenz neu aufs Display schreiben
					if (freq_hz < 10000000)			// ist Frequenz kleiner als 10 MHz?
					{
						lcd_puts(" ");
					}
					lcd_puts((char*)&frequenz);		// ausgeben auf LCD
					key_beep_error();
					bitvar.freq_update = 0;			// Frequenz gendert
					bitvar.freq_input = 0;			// Frequenzeingabe beendet
					redraw = 1;
					return;
				}
			if (vfo == 0x00)
			{
				band = band_a;
				eeprom_write_byte((uint8_t*)&EE_BAND_A, band); 	// das Band im EEPROM speichern	
				eeprom_read_block(&attenuator, &EE_ATT_A, sizeof(uint32_t)); // Attenuatorset frs passende Band laden
			}
			else
			{
				band = band_b;
				eeprom_write_byte((uint8_t*)&EE_BAND_B, band); 	// das Band im EEPROM speichern	
				eeprom_read_block(&attenuator, &EE_ATT_B, sizeof(uint32_t)); // Attenuatorset frs passende Band laden
			}
			lcd_gotoxy(0, 3);				// schreibe das Band
			if (band == 0x01)				// 160m
				lcd_puts("160m");
			else if (band == 0x02)			// 80m
				lcd_puts(" 80m");
			else if (band == 0x03)			// 40m
				lcd_puts(" 40m");
			else if (band == 0x04)			// 30m
				lcd_puts(" 30m");
			else if (band == 0x05)			// 20m
				lcd_puts(" 20m");
			else if (band == 0x06)			// 17m
				lcd_puts(" 17m");
			else if (band == 0x07)			// 15m
				lcd_puts(" 15m");
			else if (band == 0x08)			// 12m
				lcd_puts(" 12m");
			else if (band == 0x09)			// 10m
				lcd_puts(" 10m");
			else if (band == 0x0A)			// 6m
				lcd_puts("  6m");
			bitvar.freq_update = 1;			// Frequenz gendert
			bitvar.freq_update_lcd = 1;		// LCD Frequenz ndern
			redraw = 0;						// Wert nicht nochmal schreiben
			stelle = 0;
			key_beep_long();
			key = 0;
			bitvar.freq_input = 0;			// Frequenzeingabe beendet;
			save_band(freq_hz);				// die Frequenz vom alten Band speichern
			Rx_Relais &= 0x3FF; 			// die Att lschen, nur die Bnder behalten
			if (band == 0x01)					// 160m
			{
				Rx_Relais |= ((attenuator & 0x03) * 1024);
			}
			else if (band == 0x02)				// 80m
			{
				Rx_Relais |= ((attenuator & 0x0C) * 256);
			}
			else if (band == 0x03)				// 40m
			{
				Rx_Relais |= ((attenuator & 0x30) * 64);
			}
			else if (band == 0x04)				// 30m
			{
				Rx_Relais |= ((attenuator & 0xC0) * 16);
			}
			else if (band == 0x05)				// 20m
			{
				Rx_Relais |= ((attenuator & 0x300) * 4);
			}
			else if (band == 0x06)				// 17m
			{
				Rx_Relais |= (attenuator & 0xC00);
			}
			else if (band == 0x07)				// 15m
			{
				Rx_Relais |= ((attenuator & 0x3000) / 4);
			}
			else if (band == 0x08)				// 12m
			{
				Rx_Relais |= ((attenuator & 0xC000) / 16);
			}
			else if (band == 0x09)				// 10m
			{
				Rx_Relais |= ((attenuator & 0x30000) / 64);
			}
			else if (band == 0x0A)				// 6m
			{
				Rx_Relais |= ((attenuator & 0xC0000) / 256);	
			}
			leds &= ATT_0dB_LED;						// alle LEDs aus
			if ((Rx_Relais & 0xC00) == 0x400)
				leds |= ATT_10dB_LED;
			else if ((Rx_Relais & 0xC00) == 0x800)
				leds |= ATT_20dB_LED;
			else if ((Rx_Relais & 0xC00) == 0xC00)
				leds |= ATT_30dB_LED;
			LED_onoff(Front_LED); LED_onoff(Rx);
		}
		key = 0;
	}
}


///////////////////////////////////////////////////////////////////////////////
//
//	Plus oder Minus 1 MHz, maximale Frequenz = 51 MHz, minimale Frequenz = 1 MHz
//
///////////////////////////////////////////////////////////////////////////////
void MHz(uint8_t temp)
{
	uint8_t band = 0;
	key_beep_short();
	if (!(leds & Lock_LED_an))							// ist das bit gelscht?
	{
		if (vfo == 0x00)
			band = band_a;
		else
			band = band_b;
		if (temp == 10)
		{
			if (((band == 0x01) && ((freq_hz + 1000000) > 2000000)) || ((band == 0x02) && ((freq_hz + 1000000) > 3800000)) ||
				((band == 0x03) && ((freq_hz + 1000000) > 7200000)) || ((band == 0x04) && ((freq_hz + 1000000) > 10150000)) ||
				((band == 0x05) && ((freq_hz + 1000000) > 14350000)) || ((band == 0x06) && ((freq_hz + 1000000) > 18168000)) ||
				((band == 0x07) && ((freq_hz + 1000000) > 21450000)) || ((band == 0x08) && ((freq_hz + 1000000) > 24990000)) ||
				((band == 0x09) && ((freq_hz + 1000000) > 29700000)) || ((band == 0x0A) && ((freq_hz + 1000000) > 52000000)))
			return;
			freq_counter = 0;
			freq_hz += 1000000;						// addieren 1 MHz
		}
		else if (temp == 5)
		{
			if (((band == 0x01) && ((freq_hz - 1000000) < 1810000)) || ((band == 0x02) && ((freq_hz - 1000000) < 3500000)) ||
				((band == 0x03) && ((freq_hz - 1000000) < 7000000)) || ((band == 0x04) && ((freq_hz - 1000000) < 10100000)) ||
				((band == 0x05) && ((freq_hz - 1000000) < 14000000)) || ((band == 0x06) && ((freq_hz - 1000000) < 18068000)) ||
				((band == 0x07) && ((freq_hz - 1000000) < 21000000)) || ((band == 0x08) && ((freq_hz - 1000000) < 24890000)) ||
				((band == 0x09) && ((freq_hz - 1000000) < 28000000)) || ((band == 0x0A) && ((freq_hz - 1000000) < 50080000)))
			return;
			freq_counter = 0;
			freq_hz -= 1000000;						// subtrahiere 1 MHz
		}
		else
			return;
		bitvar.freq_update = 1;						// Frequenz gendert
		bitvar.freq_update_lcd = 1;		// LCD Frequenz ndern
	}
}


///////////////////////////////////////////////////////////////////////////////
//
//	Band hoch oder runter
//
///////////////////////////////////////////////////////////////////////////////
void Band(uint8_t temp)
{	
	uint8_t band = 0;
	uint32_t attenuator = 0;

	key_beep_short();
	bitvar.freq_update = 0;							// Frequenz nicht nach 3 s im EEPROM speichern
	if (!(leds & Lock_LED_an))						// ist das bit gelscht?
	{
		rit_off();									// RIT ausschalten wenn aktiv gewesen.
		if (vfo == 0x00)
			band = band_a;
		else
			band = band_b;
		if (temp == 9)								// Taste Band up
		{
			if (band == 0x0A)						// schon im 6m Band?
				return;
			band += 1;								// Ein KW Band hher
		}
		else if (temp == 4)							// Taste Band down
		{
			if (band == 0x01)						// schon im 160m Band?
				return;
			band -= 1;								// Ein KW Band tiefer
		}
		else
			return;
		save_band(freq_hz);							// die Frequenz vom alten Band speichern
		if (vfo == 0x00)							// VFA A
		{
			eeprom_write_byte((uint8_t*)&EE_BAND_A, band); 	// das neue Band im EEPROM speichern	
			eeprom_read_block((uint32_t*)&attenuator, &EE_ATT_A, sizeof(uint32_t)); // Attenuatorset frs passende Band laden
			Rx_Relais &= 0x3FF; 					// die Att lschen, nur die Bnder behalten
			band_a = band;
			// Empfangsfilter einstellen
			if (band_a == 0x01)						// 160m
			{
				Rx_Relais |= ((attenuator & 0x03) * 1024);
			}
			else if (band_a == 0x02)				// 80m
			{
				Rx_Relais |= ((attenuator & 0x0C) * 256);
			}
			else if (band_a == 0x03)				// 40m
			{
				Rx_Relais |= ((attenuator & 0x30) * 64);
			}
			else if (band_a == 0x04)				// 30m
			{
				Rx_Relais |= ((attenuator & 0xC0) * 16);
			}
			else if (band_a == 0x05)				// 20m
			{
				Rx_Relais |= ((attenuator & 0x300) * 4);
			}
			else if (band_a == 0x06)				// 17m
			{
				Rx_Relais |= (attenuator & 0xC00);
			}
			else if (band_a == 0x07)				// 15m
			{
				Rx_Relais |= ((attenuator & 0x3000) / 4);
			}
			else if (band_a == 0x08)				// 12m
			{
				Rx_Relais |= ((attenuator & 0xC000) / 16);
			}
			else if (band_a == 0x09)				// 10m
			{
				Rx_Relais |= ((attenuator & 0x30000) / 64);
			}
			else if (band_a == 0x0A)				// 6m
			{
				Rx_Relais |= ((attenuator & 0xC0000) / 256);	
			}
		}
		else										// VFO B
		{
			eeprom_write_byte((uint8_t*)&EE_BAND_B, band); 	// das Band im EEPROM speichern	
			eeprom_read_block(&attenuator, &EE_ATT_B, sizeof(uint32_t)); // Attenuatorset frs passende Band laden
			Rx_Relais &= 0x3FF; 					// die Att lschen, nur die Bnder behalten
			band_b = band;
			// Empfangsfilter einstellen
			if (band_b == 0x01)						// 160m
			{
				Rx_Relais |= ((attenuator & 0x03) * 1024);
			}
			else if (band_b == 0x02)				// 80m
			{
				Rx_Relais |= ((attenuator & 0x0C) * 256);
			}
			else if (band_b == 0x03)				// 40m
			{
				Rx_Relais |= ((attenuator & 0x30) * 64);
			}
			else if (band_b == 0x04)				// 30m
			{
				Rx_Relais |= ((attenuator & 0xC0) * 16);
			}
			else if (band_b == 0x05)				// 20m
			{
				Rx_Relais |= ((attenuator & 0x300) * 4);
			}
			else if (band_b == 0x06)				// 17m
			{
				Rx_Relais |= (attenuator & 0xC00);
			}
			else if (band_b == 0x07)				// 15m
			{
				Rx_Relais |= ((attenuator & 0x3000) / 4);
			}
			else if (band_b == 0x08)				// 12m
			{
				Rx_Relais |= ((attenuator & 0xC000) / 16);
			}
			else if (band_b == 0x09)				// 10m
			{
				Rx_Relais |= ((attenuator & 0x30000) / 64);
			}
			else if (band_b == 0x0A)				// 6m
			{
				Rx_Relais |= ((attenuator & 0xC0000) / 256);	
			}
		}
		leds &= ATT_0dB_LED;						// alle LEDs aus
		if ((Rx_Relais & 0xC00) == 0x400)			// passende LED einschalten
			leds |= ATT_10dB_LED;
		else if ((Rx_Relais & 0xC00) == 0x800)
			leds |= ATT_20dB_LED;
		else if ((Rx_Relais & 0xC00) == 0xC00)
			leds |= ATT_30dB_LED;
		LED_onoff(Front_LED); LED_onoff(Rx);		// Relais und LEDs setzen
		freq_hz = load_band();						// die Frequenz vom neuen Band laden
		if (vfo == 0x00)							// VFO A
			band = band_a;
		else										// VFO B
			band = band_b;
		ant = load_ant(band);
		start_menu();
	}
}


///////////////////////////////////////////////////////////////////////////////
//
//	Blockieren des VFO Drehknopfs
//
///////////////////////////////////////////////////////////////////////////////
void Lock(void)
{
	key_beep_short();
	if (leds & Lock_LED_an)		// ist das bit gesetzt?
		leds &= Lock_LED_aus;	// dann LED aus
	else 
		leds |= Lock_LED_an;	// dann LED an
	LED_onoff(Front_LED);
}

///////////////////////////////////////////////////////////////////////////////
//
//	Auswahl des VFO A oder B
//
///////////////////////////////////////////////////////////////////////////////
void VFO_AB(void)
{
	uint8_t band, temp_mode = 0, temp_AGC = 0;
	uint32_t temp = 0, temp2 = 0;

	key_beep_short();
	bitvar.freq_update = 0;										// Frequenz nicht nach 3 s im EEPROM speichern
	if (!(leds & Lock_LED_an))									// ist das bit gelscht?
	{
		rit_off();												// RIT ausschalten wenn aktiv gewesen.
		save_band(freq_hz);
		lcd_gotoxy(6,3); 
		temp_AGC = AGC;											// speichere alten AGC Wert
		if (vfo == 0x00)										// VFO A gewhlt
		{
			lcd_puts("VFO B");
			band = band_a;
			eeprom_write_word((uint16_t*)&EE_LED_A, leds);		// alten Wert speichern
			leds = eeprom_read_word((uint16_t*)&EE_LED_B);		// Zustand der LEDs laden
			AGC = eeprom_read_byte((uint8_t*)&EE_AGC_B);		// AGC frs aktuelle Band laden
			vfo = 0x01;											// dann auf B umschalten
		}
		else													// VFO A gewhlt
		{
			lcd_puts("VFO A");
			band = band_b;
			eeprom_write_word((uint16_t*)&EE_LED_B, leds);		// alten Wert speichern
			leds = eeprom_read_word((uint16_t*)&EE_LED_A);		// Zustand der LEDs laden
			AGC = eeprom_read_byte((uint8_t*)&EE_AGC_A);		// AGC frs aktuelle Band laden
			vfo = 0x00;											// sonst auf A umschalten
		}
		if (AGC == 1)
			leds |= AGC_LED_an;									// Led fr AGC an
		else
			leds &= AGC_LED_aus;								// Led fr AGC aus
		LED_onoff(Front_LED);
		Rx_Relais &= 0x3FF; 									// die Att lschen, nur die Bnder behalten
		if (vfo == 0x00)
		{
			band = band_a;
			eeprom_read_block(&temp, &EE_ATT_A, sizeof(uint32_t));
		}
		else
		{
			band = band_b;
			eeprom_read_block(&temp, &EE_ATT_B, sizeof(uint32_t));
		}
		switch (band)
		{
			case 1:
				temp2 = (temp & 0x03);		// nur die 160m ATT auswerten
				temp &= 0xFFFFFFFC;			// all ATT aus
				if (temp2 == 0x01)			// ATT = 10 dB
					Rx_Relais |= ATT_10dB;
				else if (temp2 == 0x02)		// ATT = 20 dB
					Rx_Relais |= ATT_20dB;
				else if (temp2 == 0x03)		// ATT = 30 dB
					Rx_Relais |= ATT_30dB;
			break;
			case 2:
				temp2 = (temp & 0x0C);		// nur die 80m ATT auswerten
				temp &= 0xFFFFFFF3;			// all ATT aus
				if (temp2 == 0x04)			// ATT = 10 dB
					Rx_Relais |= ATT_10dB;
				else if (temp2 == 0x08)		// ATT = 20 dB
					Rx_Relais |= ATT_20dB;
				else if (temp2 == 0x0C)		// ATT = 30 dB
					Rx_Relais |= ATT_30dB;
			break;
			case 3:
				temp2 = (temp & 0x30);		// nur die 40m ATT auswerten
				temp &= 0xFFFFFFCF;			// all ATT aus
				if (temp2 == 0x10)			// ATT = 10 dB
					Rx_Relais |= ATT_10dB;
				else if (temp2 == 0x20)		// ATT = 20 dB
					Rx_Relais |= ATT_20dB;
				else if (temp2 == 0x30)		// ATT = 30 dB
					Rx_Relais |= ATT_30dB;
			break;
			case 4:
				temp2 = (temp & 0xC0);		// nur die 30m ATT auswerten
				temp &= 0xFFFFFF3F;			// all ATT aus
				if (temp2 == 0x40)			// ATT = 10 dB
					Rx_Relais |= ATT_10dB;
				else if (temp2 == 0x80)		// ATT = 20 dB
					Rx_Relais |= ATT_20dB;
				else if (temp2 == 0xC0)		// ATT = 30 dB
					Rx_Relais |= ATT_30dB;
			break;
			case 5:
				temp2 = (temp & 0x300);		// nur die 20m ATT auswerten
				temp &= 0xFFFFFCFF;			// all ATT aus
				if (temp2 == 0x100)			// ATT = 10 dB
					Rx_Relais |= ATT_10dB;
				else if (temp2 == 0x200)	// ATT = 20 dB
					Rx_Relais |= ATT_20dB;
				else if (temp2 == 0x300)	// ATT = 30 dB
					Rx_Relais |= ATT_30dB;
			break;
			case 6:
				temp2 = (temp & 0xC00);		// nur die 17m ATT auswerten
				temp &= 0xFFFFF3FF;			// all ATT aus
				if (temp2 == 0x400)			// ATT = 10 dB
					Rx_Relais |= ATT_10dB;
				else if (temp2 == 0x800)	// ATT = 20 dB
					Rx_Relais |= ATT_20dB;
				else if (temp2 == 0xC00)	// ATT = 30 dB
					Rx_Relais |= ATT_30dB;		
			break;			
			case 7:
				temp2 = (temp & 0x3000);	// nur die 15m ATT auswerten
				temp &= 0xFFFFCFFF;			// all ATT aus
				if (temp2 == 0x1000)	// ATT = 10 dB
					Rx_Relais |= ATT_10dB;
				else if (temp2 == 0x2000)	// ATT = 20 dB
					Rx_Relais |= ATT_20dB;
				else if (temp2 == 0x3000)	// ATT = 30 dB
					Rx_Relais |= ATT_30dB;
			break;
			case 8:
				temp2 = (temp & 0xC000);	// nur die 12m ATT auswerten
				temp &= 0xFFFF3FFF;			// all ATT aus
				if (temp2 == 0x4000)	// ATT = 10 dB
					Rx_Relais |= ATT_10dB;
				else if (temp2 == 0x8000)	// ATT = 20 dB
					Rx_Relais |= ATT_20dB;
				else if (temp2 == 0xC000)	// ATT = 30 dB
					Rx_Relais |= ATT_30dB;
				break;
			case 9:
				temp2 = (temp & 0x30000);	// nur die 10m ATT auswerten
				temp &= 0xFFFCFFFF;			// all ATT aus
				if (temp2 == 0x10000)	// ATT = 10 dB
					Rx_Relais |= ATT_10dB;
				else if (temp2 == 0x20000)	// ATT = 20 dB
					Rx_Relais |= ATT_20dB;
				else if (temp2 == 0x30000)	// ATT = 30 dB
					Rx_Relais |= ATT_30dB;
				break;
			case 10:
				temp2 = (temp & 0xC0000);	// nur die 6m ATT auswerten
				temp &= 0xFFF3FFFF;			// all ATT aus
				if (temp2 == 0x40000)	// ATT = 10 dB
					Rx_Relais |= ATT_10dB;
				else if (temp2 == 0x80000)	// ATT = 20 dB
					Rx_Relais |= ATT_20dB;
				else if (temp2 == 0xC0000)	// ATT = 30 dB
					Rx_Relais |= ATT_30dB;
				break;
		}
		LED_onoff(Rx);
		eeprom_write_byte((uint8_t*)&EE_VFO_AB, vfo);			// aktuellen VFO speichern
		freq_hz = load_band();
//		bitvar.freq_update = 1;									// Frequenz gendert
		bitvar.freq_update_lcd = 1;								// LCD Frequenz ndern
		temp_mode = load_mode(band, vfo);						// lade aktuellen Mode
		if ((mode != temp_mode) | (temp_AGC != AGC))
		{
			mode = temp_mode;
			Init_DSP(mode, vfo);								// Mode einstellen
		}
//		Init_DSP(mode, vfo);									// den DSP initialisieren
		ant = load_ant(band);
		start_menu();
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//	Auswahl der Eingangsdmpfung 10/20/30 dB
//
///////////////////////////////////////////////////////////////////////////////
void ATTENUATOR(void)
{
	uint8_t band = 0;
	uint32_t temp = 0, temp2 = 0;
	key_beep_short();
	Rx_Relais &= 0x3FF; 				// die Att lschen, nur die Bnder behalten
	if (vfo == 0x00)
	{
		band = band_a;
		eeprom_read_block(&temp, &EE_ATT_A, sizeof(uint32_t));
	}
	else
	{
		band = band_b;
		eeprom_read_block(&temp, &EE_ATT_B, sizeof(uint32_t));
	}
	leds &= ATT_0dB_LED;				// alle LEDs aus
	switch (band)
	{
		case 1:
			temp2 = (temp & 0x03);		// nur die 160m ATT auswerten
			temp &= 0xFFFFFFFC;			// all ATT aus
			if (temp2 == 0x00)			// ATT = 0 dB
			{
				leds |= ATT_10dB_LED;
				Rx_Relais |= ATT_10dB;
				temp |= 0x01;
			}
			else if (temp2 == 0x01)		// ATT = 10 dB
			{
				leds |= ATT_20dB_LED;
				Rx_Relais |= ATT_20dB;
				temp |= 0x02;
			}
			else if (temp2 == 0x02)		// ATT = 20 dB
			{
				leds |= ATT_30dB_LED;
				Rx_Relais |= ATT_30dB;
				temp |= 0x03;
			}
			else if (temp2 == 0x03)		// ATT = 30 dB
			{
				leds &= ATT_0dB_LED;
			}
		break;
		case 2:
			temp2 = (temp & 0x0C);		// nur die 80m ATT auswerten
			temp &= 0xFFFFFFF3;			// all ATT aus
			if (temp2 == 0x00)			// ATT = 0 dB
			{
				leds |= ATT_10dB_LED;
				Rx_Relais |= ATT_10dB;
				temp |= 0x04;
			}
			else if (temp2 == 0x04)		// ATT = 10 dB
			{
				leds |= ATT_20dB_LED;
				Rx_Relais |= ATT_20dB;
				temp |= 0x08;
			}
			else if (temp2 == 0x08)		// ATT = 20 dB
			{
				leds |= ATT_30dB_LED;
				Rx_Relais |= ATT_30dB;
				temp |= 0x0C;
			}
			else if (temp2 == 0x0C)		// ATT = 30 dB
			{
				leds &= ATT_0dB_LED;
			}
		break;
		case 3:
			temp2 = (temp & 0x30);		// nur die 40m ATT auswerten
			temp &= 0xFFFFFFCF;			// all ATT aus
			if (temp2 == 0x00)			// ATT = 0 dB
			{
				leds |= ATT_10dB_LED;
				Rx_Relais |= ATT_10dB;
				temp |= 0x10;
			}
			else if (temp2 == 0x10)		// ATT = 10 dB
			{
				leds |= ATT_20dB_LED;
				Rx_Relais |= ATT_20dB;
				temp |= 0x20;
			}
			else if (temp2 == 0x20)		// ATT = 20 dB
			{
				leds |= ATT_30dB_LED;
				Rx_Relais |= ATT_30dB;
				temp |= 0x30;
			}
			else if (temp2 == 0x30)		// ATT = 30 dB
			{
				leds &= ATT_0dB_LED;
			}
		break;
		case 4:
			temp2 = (temp & 0xC0);		// nur die 30m ATT auswerten
			temp &= 0xFFFFFF3F;			// all ATT aus
			if (temp2 == 0x00)			// ATT = 0 dB
			{
				leds |= ATT_10dB_LED;
				Rx_Relais |= ATT_10dB;
				temp |= 0x40;
			}
			else if (temp2 == 0x40)		// ATT = 10 dB
			{
				leds |= ATT_20dB_LED;
				Rx_Relais |= ATT_20dB;
				temp |= 0x80;
			}
			else if (temp2 == 0x80)		// ATT = 20 dB
			{
				leds |= ATT_30dB_LED;
				Rx_Relais |= ATT_30dB;
				temp |= 0xC0;
			}
			else if (temp2 == 0xC0)		// ATT = 30 dB
			{
				leds &= ATT_0dB_LED;
			}
		break;
		case 5:
			temp2 = (temp & 0x300);		// nur die 20m ATT auswerten
			temp &= 0xFFFFFCFF;			// all ATT aus
			if (temp2 == 0x00)			// ATT = 0 dB
			{
				leds |= ATT_10dB_LED;
				Rx_Relais |= ATT_10dB;
				temp |= 0x100;
			}
			else if (temp2 == 0x100)	// ATT = 10 dB
			{
				leds |= ATT_20dB_LED;
				Rx_Relais |= ATT_20dB;
				temp |= 0x200;
			}
			else if (temp2 == 0x200)	// ATT = 20 dB
			{
				leds |= ATT_30dB_LED;
				Rx_Relais |= ATT_30dB;
				temp |= 0x300;
			}
			else if (temp2 == 0x300)	// ATT = 30 dB
			{
				leds &= ATT_0dB_LED;
			}
		break;
		case 6:
			temp2 = (temp & 0xC00);		// nur die 17m ATT auswerten
			temp &= 0xFFFFF3FF;			// all ATT aus
			if (temp2 == 0x00)			// ATT = 0 dB
			{
				leds |= ATT_10dB_LED;
				Rx_Relais |= ATT_10dB;
				temp |= 0x400;
			}
			else if (temp2 == 0x400)	// ATT = 10 dB
			{
				leds |= ATT_20dB_LED;
				Rx_Relais |= ATT_20dB;
				temp |= 0x800;
			}
			else if (temp2 == 0x800)	// ATT = 20 dB
			{
				leds |= ATT_30dB_LED;
				Rx_Relais |= ATT_30dB;
				temp |= 0xC00;
			}
			else if (temp2 == 0xC00)	// ATT = 30 dB
			{
				leds &= ATT_0dB_LED;
			}
		break;			
		case 7:
			temp2 = (temp & 0x3000);	// nur die 15m ATT auswerten
			temp &= 0xFFFFCFFF;			// all ATT aus
			if (temp2 == 0x00)			// ATT = 0 dB
			{
				leds |= ATT_10dB_LED;
				Rx_Relais |= ATT_10dB;
				temp |= 0x1000;
			}
			else if (temp2 == 0x1000)	// ATT = 10 dB
			{
				leds |= ATT_20dB_LED;
				Rx_Relais |= ATT_20dB;
				temp |= 0x2000;
			}
			else if (temp2 == 0x2000)	// ATT = 20 dB
			{
				leds |= ATT_30dB_LED;
				Rx_Relais |= ATT_30dB;
				temp |= 0x3000;
			}
			else if (temp2 == 0x3000)	// ATT = 30 dB
			{
				leds &= ATT_0dB_LED;
			}
		break;
		case 8:
			temp2 = (temp & 0xC000);	// nur die 12m ATT auswerten
			temp &= 0xFFFF3FFF;			// all ATT aus
			if (temp2 == 0x00)			// ATT = 0 dB
			{
				leds |= ATT_10dB_LED;
				Rx_Relais |= ATT_10dB;
				temp |= 0x4000;
			}
			else if (temp2 == 0x4000)	// ATT = 10 dB
			{
				leds |= ATT_20dB_LED;
				Rx_Relais |= ATT_20dB;
				temp |= 0x8000;
			}
			else if (temp2 == 0x8000)	// ATT = 20 dB
			{
				leds |= ATT_30dB_LED;
				Rx_Relais |= ATT_30dB;
				temp |= 0xC000;
			}
			else if (temp2 == 0xC000)	// ATT = 30 dB
			{
				leds &= ATT_0dB_LED;
			}
		break;
		case 9:
			temp2 = (temp & 0x30000);	// nur die 10m ATT auswerten
			temp &= 0xFFFCFFFF;			// all ATT aus
			if (temp2 == 0x00)			// ATT = 0 dB
			{
				leds |= ATT_10dB_LED;
				Rx_Relais |= ATT_10dB;
				temp |= 0x10000;
			}
			else if (temp2 == 0x10000)	// ATT = 10 dB
			{
				leds |= ATT_20dB_LED;
				Rx_Relais |= ATT_20dB;
				temp |= 0x20000;
			}
			else if (temp2 == 0x20000)	// ATT = 20 dB
			{
				leds |= ATT_30dB_LED;
				Rx_Relais |= ATT_30dB;
				temp |= 0x30000;
			}
			else if (temp2 == 0x30000)	// ATT = 30 dB
			{
				leds &= ATT_0dB_LED;
			}
		break;
		case 10:
			temp2 = (temp & 0xC0000);	// nur die 6m ATT auswerten
			temp &= 0xFFF3FFFF;			// all ATT aus
			if (temp2 == 0x00)			// ATT = 0 dB
			{
				leds |= ATT_10dB_LED;
				Rx_Relais |= ATT_10dB;
				temp |= 0x40000;
			}
			else if (temp2 == 0x40000)	// ATT = 10 dB
			{
				leds |= ATT_20dB_LED;
				Rx_Relais |= ATT_20dB;
				temp |= 0x80000;
			}
			else if (temp2 == 0x80000)	// ATT = 20 dB
			{
				leds |= ATT_30dB_LED;
				Rx_Relais |= ATT_30dB;
				temp |= 0xC0000;
			}
			else if (temp2 == 0xC0000)	// ATT = 30 dB
			{
				leds &= ATT_0dB_LED;
			}
		break;
	}
	if (vfo == 0x00)
		eeprom_write_block((uint32_t *)&temp, (uint8_t*) &EE_ATT_A, sizeof(uint32_t));
	else
		eeprom_write_block((uint32_t *)&temp, (uint8_t*) &EE_ATT_B, sizeof(uint32_t));
	LED_onoff(Front_LED); LED_onoff(Rx);
	if (leds & RIT_an)										// ist das bit gesetzt?
		leds &= RIT_aus;									// dann LED aus
	else
		leds |= RIT_an;										
	rit_LED();
}
