// DDS Generator mit AD9854
//
// Erstellt von: Marcus Pool
// 
// www.Marcus-Pool.de
//
// Version 0.45
//
// Versionshistorie
// 0.00 - 18.03.2008 Start mit der Software
// 0.41	- 25.03.2011
//		- Rx Antennen umschalten und Tx Tiefpass Relais richtig schalten
//		- AGC ok
// 0.42 - 08.07.2011
//		- Wenn Men aktive Frequenznderung sperren.
//		- DSP nicht neu starten bei Bandwechsel oder VFO Wechsel, wenn beide Modes gleich sind.
// 		- Bei direkter Frequenzeingabe wird der alte Mode gestartet.
//		- keine Probleme mehr mit dem LCD wenn PTT aktiv
// 0.45	- RIT Funktion neu
//		- DDS und I2C nur schreiben wenn sich etwas gendert hat
// 0.46	- 03.10.2011
//		- RIT und XIT Funktion implementiert
// 0.47 - Umlaute eingefhrt
//		- RIT und Xit mit Drehcoder drcken Frequenznderung mit Faktor 10

/*
;alles auf Ausgang
ldi    temp1,0xFF
sts    DDRG,temp1

;alles an
ldi    temp1,0xFF
sts    PortG,temp1
*/



// UNGETESTET:
//		- ant Umschaltung mit Displayanzeige bei Sendebetrieb?

// Wnsche und Anregungen
// * Frequenzspeicher einrichten, extra Taste

// PROBLEME
// * Probleme bei PWM und Drehencoder

#include <main.h>
#include <avr/io.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <stdlib.h>
#include <inttypes.h>
#include <stdio.h>
#include <rit.h>
#include <util/delay.h> 
#include <band.h>
#include <dsp.h>
#include <init.h>
#include <lcd.h>
#include <i2cmaster.h>
#include <outputs.h>
#include <matrix_keyboard.h>
#include <lcd_menu.h>
#include <dds.h>
#include <global.h>

char Buffer[20];

uint8_t edge = 1;
uint8_t test = 0;
uint8_t beep_on_off;						// Tastenton

volatile uint8_t key = 0;
volatile uint8_t encoder_counter = 0;		// Zhler fr encoder auslesen 
volatile uint8_t update = 0;
volatile uint8_t freq_update = 0;
volatile uint8_t step = 0;
volatile uint8_t mode = 0;
volatile uint8_t mode_temp = 0;
volatile uint8_t band_a = 0;
volatile uint8_t band_b = 0;
volatile uint8_t vfo = 0;					// benutzter VFO
volatile uint8_t ant = 0;					// aktuelle Antenne

volatile int16_t enc_delta=0; 	     		// +/- 32767
static   int8_t last = 0;

volatile int8_t enc_delta2=0;         		// +/- 127
static   int8_t last2 = 0;
volatile int16_t xrit_hz_temp = 0;			// Frequenz fr RIT/XIT
volatile int16_t xrit_hz_alt = 0;

volatile uint16_t freq_counter = 0;			// nach 3s wird die Frequenz gespeichert
volatile uint16_t menu_nr = 0;
volatile uint16_t leds = 0;
volatile uint16_t Rx_Relais = 0;
volatile uint16_t Tx_Relais = 0;

volatile int32_t freq_hz_temp = 0;			// Frequenznderung vom Drehgeber (alle 50ms)
volatile uint32_t freq_hz = 0;				// aktuelle Frequenz
volatile uint32_t freq_temp = 0;			// speichert die Frequenz in Hz

volatile char frequenz[11]; 				// "12.345,678", speichert die Frequenz als Character
volatile char frequenz_alt[11];				// speichert die alte Frequenz als Character

volatile struct BitVariablen{
    int menu_aktiv		:1;					// ein Men ist aktiviert
	int freq_input  	:1;					// Frequenzeingabe via 10er Tastatur aktiviert
	int	freq_update 	:1;					// 
	int freq_update_lcd	:1;					// auf dem LCD Frequenz aktualisieren
	int tx_on			:1;					// Sender eingeschaltet
	int ptt_schalten	:1;					// PTT umgeschaltet
	int rit_aktiv		:1;					// RIT Funktion aktiv
	int xit_aktiv		:1;					// XIT Funktion aktiv
}bitvar = {0};

volatile uint8_t  Tastenton 	EEMEM;		// Tastenton an/aus
volatile uint8_t  Schrittweite	EEMEM;		// Schritweite fr Encoder
volatile uint8_t  EE_AGC_A		EEMEM;		// AGC an (0) oder aus (1)
volatile uint8_t  EE_AGC_B		EEMEM;		// AGC an (0) oder aus (1)
volatile uint8_t  EE_Filter_A	EEMEM;		// Filter des DSP
volatile uint8_t  EE_Filter_B	EEMEM;		// Filter des DSP
volatile uint8_t  EE_VFO_AB		EEMEM;		// VFO A oder B
volatile uint8_t  EE_BAND_A		EEMEM;		// Bandwahl
volatile uint8_t  EE_BAND_B		EEMEM;		// Bandwahl
volatile uint16_t LCD_PWM 		EEMEM;		// PWM Wert fr LCD Beleuchtung
volatile uint16_t EE_LED_A		EEMEM;		// I2C LED Status
volatile uint16_t EE_LED_B		EEMEM;		// I2C LED Status

volatile uint32_t EE_ATT_A		EEMEM;		// Attenuator fr VFO A
volatile uint32_t EE_ATT_B		EEMEM;		// Attenuator fr VFO B
volatile uint32_t EE_freq_160_A	EEMEM;		// letzte Frequenz im 160m Band
volatile uint32_t EE_freq_80_A	EEMEM;		// letzte Frequenz im 80m Band
volatile uint32_t EE_freq_40_A	EEMEM;		// letzte Frequenz im 40m Band
volatile uint32_t EE_freq_30_A	EEMEM;		// letzte Frequenz im 30m Band
volatile uint32_t EE_freq_20_A	EEMEM;		// letzte Frequenz im 20m Band
volatile uint32_t EE_freq_17_A	EEMEM;		// letzte Frequenz im 17m Band
volatile uint32_t EE_freq_15_A	EEMEM;		// letzte Frequenz im 15m Band
volatile uint32_t EE_freq_12_A	EEMEM;		// letzte Frequenz im 12m Band
volatile uint32_t EE_freq_10_A	EEMEM;		// letzte Frequenz im 10m Band
volatile uint32_t EE_freq_6_A	EEMEM;		// letzte Frequenz im 6m Band
volatile uint32_t EE_freq_160_B	EEMEM;		// letzte Frequenz im 160m Band
volatile uint32_t EE_freq_80_B	EEMEM;		// letzte Frequenz im 80m Band
volatile uint32_t EE_freq_40_B	EEMEM;		// letzte Frequenz im 40m Band
volatile uint32_t EE_freq_30_B	EEMEM;		// letzte Frequenz im 30m Band
volatile uint32_t EE_freq_20_B	EEMEM;		// letzte Frequenz im 20m Band
volatile uint32_t EE_freq_17_B	EEMEM;		// letzte Frequenz im 17m Band
volatile uint32_t EE_freq_15_B	EEMEM;		// letzte Frequenz im 15m Band
volatile uint32_t EE_freq_12_B	EEMEM;		// letzte Frequenz im 12m Band
volatile uint32_t EE_freq_10_B	EEMEM;		// letzte Frequenz im 10m Band
volatile uint32_t EE_freq_6_B	EEMEM;		// letzte Frequenz im 6m Band

volatile uint32_t EE_MODE_160_A	EEMEM;		// letzter Mode im 160m Band
volatile uint32_t EE_MODE_80_A	EEMEM;		// letzter Mode im 80m Band
volatile uint32_t EE_MODE_40_A	EEMEM;		// letzter Mode im 40m Band
volatile uint32_t EE_MODE_30_A	EEMEM;		// letzter Mode im 30m Band
volatile uint32_t EE_MODE_20_A	EEMEM;		// letzter Mode im 20m Band
volatile uint32_t EE_MODE_17_A	EEMEM;		// letzter Mode im 17m Band
volatile uint32_t EE_MODE_15_A	EEMEM;		// letzter Mode im 15m Band
volatile uint32_t EE_MODE_12_A	EEMEM;		// letzter Mode im 12m Band
volatile uint32_t EE_MODE_10_A	EEMEM;		// letzter Mode im 10m Band
volatile uint32_t EE_MODE_6_A	EEMEM;		// letzter Mode im 6m Band
volatile uint32_t EE_MODE_160_B	EEMEM;		// letzter Mode im 160m Band
volatile uint32_t EE_MODE_80_B	EEMEM;		// letzter Mode im 80m Band
volatile uint32_t EE_MODE_40_B	EEMEM;		// letzter Mode im 40m Band
volatile uint32_t EE_MODE_30_B	EEMEM;		// letzter Mode im 30m Band
volatile uint32_t EE_MODE_20_B	EEMEM;		// letzter Mode im 20m Band
volatile uint32_t EE_MODE_17_B	EEMEM;		// letzter Mode im 17m Band
volatile uint32_t EE_MODE_15_B	EEMEM;		// letzter Mode im 15m Band
volatile uint32_t EE_MODE_12_B	EEMEM;		// letzter Mode im 12m Band
volatile uint32_t EE_MODE_10_B	EEMEM;		// letzter Mode im 10m Band
volatile uint32_t EE_MODE_6_B	EEMEM;		// letzter Mode im 6m Band

volatile uint8_t EE_ANT_160		EEMEM;		// ANT im 160m Band
volatile uint8_t EE_ANT_80		EEMEM;		// ANT im 80m Band
volatile uint8_t EE_ANT_40		EEMEM;		// ANT im 40m Band
volatile uint8_t EE_ANT_30		EEMEM;		// ANT im 30m Band
volatile uint8_t EE_ANT_20		EEMEM;		// ANT im 20m Band
volatile uint8_t EE_ANT_17		EEMEM;		// ANT im 17m Band
volatile uint8_t EE_ANT_15		EEMEM;		// ANT im 15m Band
volatile uint8_t EE_ANT_12		EEMEM;		// ANT im 12m Band
volatile uint8_t EE_ANT_10		EEMEM;		// ANT im 10m Band
volatile uint8_t EE_ANT_6		EEMEM;		// ANT im 6m Ban

///////////////////////////////////////////////////////////////////////////////
//
//	Auslesen des Hauptencoders
//
///////////////////////////////////////////////////////////////////////////////

int16_t encoder_read(void)         						// Encoderwerte auslesen
{
	int16_t val = 0;

	cli();
	val = enc_delta;									// lade aktuellen Wert
	enc_delta = val & 1;								// Wert zurcksetzen
	sei();
	
	// nur Frequenz ndern wenn kein Men aktiv und RIT/XIT aus ist
	if ((bitvar.freq_input == 0) && (bitvar.menu_aktiv == 0) && (bitvar.rit_aktiv == 0) && (bitvar.xit_aktiv == 0))
	{
		if (!(leds & Lock_LED_an))						// ist das bit gelscht und keine neue Frequenz?
		{
//			bitvar.freq_update_lcd = 1;					// LCD Frequenz gendert
			return val >> 1;
		}
		else 
			return 0;
	}
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//
//	Auslesen des Drehencoders fr RIT/XIT
//
///////////////////////////////////////////////////////////////////////////////

int8_t encoder_read_xrit(void)         					// Encoderwerte auslesen
{
	int8_t val2 = 0;

	cli();
	val2 = enc_delta2;									// lade aktuellen Wert
	enc_delta2 = val2 & 1;								// Wert zurcksetzen
	sei();

	// RIT oder XIT Funktion aktiviert
	if (((bitvar.rit_aktiv == 1) || (bitvar.xit_aktiv)) && (bitvar.menu_aktiv == 0 ) && (bitvar.tx_on == 0))
	{
		return val2 >> 1;
	}
	return 0;
}


///////////////////////////////////////////////////////////////////////////////
//
//	Hauptprogramm
//
///////////////////////////////////////////////////////////////////////////////

int main(void)
{
	int8_t band, temp, new, new2 = 0;
	uint16_t faktor = 20;

	// Initialisieren der Startvariablen
	bitvar.menu_aktiv = 0;
	bitvar.freq_input = 0;
	bitvar.freq_update = 0;
	bitvar.freq_update_lcd = 0; 
	bitvar.tx_on = 0;
	bitvar.ptt_schalten = 0;

	// x |= (1 << Bitnummer);  // Hiermit wird ein Bit in x gesetzt
	// x &= ~(1 << Bitnummer); // Hiermit wird ein Bit in x geloescht 

	// Initialisierung der Eingnge/Ausgnge
	// Eingnge
		DDRD &= ~(( 1 << ENC_A) | (1 << ENC_B) | (1<<INT) | (1<<PTT_In));
		DDRF &= ~(( 1 << ENC_A2) | (1 << ENC_B2));
		//DDRA &= ~( 1 << Taster);
	// Pull up an
		PORTD |= ((1 << PTT_In) | (1 << ENC_A) | (1 << ENC_B));
		PORTF |= ((1 << ENC_A2) | (1 << ENC_B2) | (1 << Enc2_Tast));
		//PORTA |= (1 << Taster);
	// Ausgnge
		DDRB |= (1 << PWM_LED);
		DDRB |= ((1 << 0) | (1 << 6) | (1 << 7)); 	// MReset, IOud, IOReset
		DDRB |= ((1 << 1) | (1 << 3) | (1 << 4));	// Filter_2, Filter_3, Filter_4
		DDRD |= ((1 << 4) | (1 << 5));				// SData, SClk
		DDRE |= ((1 << 2) | (1 << 3) | (1 << 4) | (1 << 5) | (1 << 6) | (1 << 7));// PTT Ausgang 1-4, Filter_res, LSB_USB
		DDRF |= ((1 << 0));							// AGC
		DDRG |= ((1 << 2) | (1 << 0));				// Summer, Filter_1

		MReset = 0; IOud = 0; IOReset = 0; SData = 0; SClk = 0;		// alle Ausgnge = 0
		Filter_1 = 1; Filter_2 = 1; Filter_3 = 1; Filter_4 = 1; Filter_res = 0;	// alle Ausgnge = 1
		PTT1 = 0; PTT2 = 0; PTT3 = 0; PTT4 = 0;
	// Interrupt
		EICRA = 0x28;							// Int0 (Drehenkoder B) low aktive, wird nicht genutzt
												// Int1 (Drehenkoder A) fallende Flanke
												// Int2 (Matrixtastatur) fallende Flanke
												// Int3	(PTT) low aktiv (fallende Flanke)
		EICRB = 0x00;							// Interrupts aus fr Int 4-7
		EIMSK |= ((1<<INT2));// | (1<<INT3));		// aktiviere Int2 und Int3
	// AD Converter Initialisierung
	//	ADMUX = 0x41;							// Referenz Spannung = AVCC mit Kondensator an AREF Pin, ADC1 aktiviert
	//	ADCSRA = 0xE7;							// ADC off, FreeRunning, no Interrupt, CLK / 128
	
	// Hauptencoder Initialisierung
		new = 0;
		if (PHASE_B)
			new = 3;
		if (PHASE_A)
			new ^= 1;                   		// convert gray to binary
		last = new;                   			// power on state

	// Drehencoder fr RIT/XIT Initialisierung
		new2 = 0;
		if (PHASE_B2)
			new2 = 3;
		if (PHASE_A2)
			new2 ^= 1;                   		// convert gray to binary
		last2 = new2;                   		// power on state

	// Timer 0
		TCCR0 |= ((1 << WGM01) | (1 << CS02));		// CTC, 1/64
		//OCR0 = (uint8_t)(XTAL / 64.0 * 1e-3 - 0.5); // 1ms
		OCR0 = 50;									// 200 s
		TIMSK |= 1<<OCIE0;							// Timer/Counter0 Compare Match interrupt is enabled
	// Initialisierung von Routinen und Ein/Ausgnge
	 	PORTG &= ~(1<<2);							// Summer aus
	// Timer 1
		TCCR1A = (1<<WGM11)| (1<<COM1A1)|(1<<COM1A0);	// 9bit Timer invertiert,TOP bei 512
		TCCR1B = (1<<CS10);								// Vorteiler auf 1 setzen
	
	// Start der Initialisierung
		_delay_ms(1000);
		Init_DDS();								// Initialisieren des AD9854 DDS
		lcd_init(LCD_DISP_ON);					// Display on, no cursor
		Init_AVR();								// EEPROM initialieren oder Werte laden, Startscreen
		pcf9555_init();
		init_keyboard();						// Matrixtastatur aktivieren
		_delay_ms(500);
		sei();									// alle Interrupts aktivieren

// start des Hauptprogramms
		while(1)								// Schleife des Hauptprogramms
	    {
// Relais zum Filtervermessen dauerhaft setzen
// Tx_Relais |= Tx_an_;
			if (bitvar.tx_on == 1)								// Sender an?
			{
				if (bitvar.ptt_schalten == 1)					// Sender einschalten
				{
					if (bitvar.rit_aktiv == 1)					// Bei RIT Rx Frequenz auf normale Frequenz einstellen
						convertDDS(freq_hz);					// Ausgabe der alten Frequenz ohne RIT zum DDS
					if (bitvar.xit_aktiv == 1)					// Bei XIT Tx Frequenz auf Tx + RIT einstellen
						convertDDS(freq_hz + (xrit_hz_temp*10));// Ausgabe der Frequenz + XIT zum DDS
					TIMSK &= ~(1<<OCIE0);						// Timer/Counter0 Compare Match interrupt is disabled
					leds |= PTT_LED_an;							// Led an
					// Relais im Display zeigen
					lcd_gotoxy(4,2);							// Cursor fr Relaisanzeige setzen
					temp = ant & 0xF0;							// nur Tx Antenne auswerten
					if (temp == 0x10)
						lcd_puts("1");
					else if (temp == 0x20)
						lcd_puts("2");
					else if (temp == 0x30)
						lcd_puts ("3");
					// PTT Sequenzer							// einschalten der Ausgnge
					PTT1 = 1; _delay_ms(20); 
					PTT2 = 1; _delay_ms(20); 
					PTT3 = 1; _delay_ms(20);
					PTT4 = 1;
					// PTT Sequenzer
					Tx_Relais |= (Ant1_aus | Ant2_aus | Ant3_aus);// die Antennenrelais lschen, alle auf '1' setzen
					temp = ant & 0xF0;							// nur Tx Antenne auswerten
					if (temp == 0x10)
						Tx_Relais &= Ant1_an;
					else if (temp == 0x20)
						Tx_Relais &= Ant2_an;
					else if (temp == 0x30)
						Tx_Relais &= Ant3_an;
					Tx_Relais |= Rx_an;							// Relais schalten fr Rx
					bitvar.ptt_schalten = 0;
					LED_onoff(Front_LED); LED_onoff(Tx);		// I2C Ausgnge schalten
					TIMSK |= 1<<OCIE0;							// Timer/Counter0 Compare Match interrupt is enabled
				}
			}
			else
			{
				if (bitvar.ptt_schalten == 1)					// Sender ausschalten
				{
					if (bitvar.rit_aktiv == 1)					// Bei RIT Rx Frequenz auf Rx + RIT einstellen
						convertDDS(freq_hz + (xrit_hz_temp*10));// Ausgabe der Frequenz zum DDS				
					if (bitvar.xit_aktiv == 1)					// BEI XIT Rx Frequenz auf normale Frequenz einstellen
						convertDDS(freq_hz);					// Ausgabe der alten Frequenz ohne RIT zum DDS
					TIMSK &= ~(1<<OCIE0);						// Timer/Counter0 Compare Match interrupt is disabled
					// Relais im Display anzeigen
					lcd_gotoxy(4,2);							// Cursor fr Relaisanzeige setzen
					temp = ant & 0x0F;							// nur Rx Antenne auswerten
					if (temp == 0x01)
						lcd_puts("1");
					else if (temp == 0x02)
						lcd_puts("2");
					else if (temp == 0x03)
						lcd_puts ("3");
					// PTT Sequenzer							// ausschalten der Ausgnge 
					PTT4 = 0; _delay_ms(20);
					PTT3 = 0; _delay_ms(20);
					PTT2 = 0; _delay_ms(20);
					PTT1 = 0;
					// PTT Sequenzer
					temp = ant & 0x0F;							// nur Rx Antenne auswerten
					Tx_Relais |= (Ant1_aus | Ant2_aus | Ant3_aus);// die Antennenrelais lschen, alle auf '1' setzen
					if (temp == 0x01)
						Tx_Relais &= Ant1_an;
					else if (temp == 0x02)
						Tx_Relais &= Ant2_an;
					else if (temp == 0x03)
						Tx_Relais &= Ant3_an;
					leds &= PTT_LED_aus;						// Led aus
					Tx_Relais &= Tx_an;							// Relais schalten fr Tx
					bitvar.tx_on = 0;							// Sender aus
					EICRA &= ~(1 << ISC30);						// Interrupt bei fallender Flanke 
					bitvar.ptt_schalten = 0;
					LED_onoff(Front_LED); LED_onoff(Tx);		// I2C Ausgnge schalten
					TIMSK |= 1<<OCIE0;							// Timer/Counter0 Compare Match interrupt is enabled
				}
			}

			xrit_hz_alt = xrit_hz_temp;							// alten Wert speichern

			if (Enc2_Taster)									// Taster gedrck dann Frequenz mit Faktor 10 ndern
				xrit_hz_temp += encoder_read_xrit();			// neuen Wert laden
			else 
				xrit_hz_temp += (encoder_read_xrit() * 10);		// neuen Wert laden
			if ((bitvar.rit_aktiv == 1) || (bitvar.xit_aktiv == 1))	// RIT oder XIT Funktion an?
			{
				if (xrit_hz_temp > 990)
				{			
					xrit_hz_temp = 990;
	 			}
				if (xrit_hz_temp < -990)
				{
					xrit_hz_temp = -990;
				}
				rit(xrit_hz_temp);
				if ((xrit_hz_alt != xrit_hz_temp) && (bitvar.rit_aktiv == 1))
					convertDDS(freq_hz + (xrit_hz_temp * 10));	// Ausgabe der Frequenz zum DDS				
			}
			else
				xrit_hz_temp = 0;								// Wert zurcksetzen nach ausschalten der RIT Funktion

			freq_hz_temp += encoder_read(); 					// Encoderwerte auslesen

			// nur neue Frequenz schreiben wenn nicht in einem Men und eine neue Frequenz vorhanden ist
			if ((bitvar.freq_input == 0) && (bitvar.menu_aktiv == 0) && (bitvar.freq_update_lcd == 1) && (freq_hz_temp != 0))
			{
				bitvar.freq_update_lcd = 0;		// LCD Frequenz gendert

				if (step == 1)
					faktor = 1;
				else if (step == 2)
					faktor = 10;
				else if (step == 3)
					faktor = 50;
				else if (step == 4)
					faktor = 100;
				else if (step == 5)
					faktor = 500;
				else if (step == 6)
					faktor = 1000;
				if (vfo == 0x00)
					band = band_a;
				else
					band = band_b;
				if (band == 1) 										// 160m
				{
					if ((freq_hz + freq_hz_temp * faktor) >= 2000000)// max. Frequenz erreicht
						freq_hz = freq_hz + (freq_hz_temp * faktor) - 190000;
					else if ((freq_hz + freq_hz_temp * faktor) < 1810000)// min Frequenz erreicht
						freq_hz += (freq_hz_temp * faktor) + 190000;
					else 											// zwischen den Grenzfrequenzen
						freq_hz += (freq_hz_temp * faktor);
				}
				else if (band == 2)									// 80m
				{	
					if ((freq_hz + freq_hz_temp * faktor) >= 3800000)// max. Frequenz erreicht
						freq_hz = freq_hz + (freq_hz_temp * faktor) - 300000;
					else if ((freq_hz + freq_hz_temp * faktor) < 3500000)// min Frequenz erreicht
						freq_hz += (freq_hz_temp * faktor) + 300000;
					else 											// zwischen den Grenzfrequenzen
						freq_hz += (freq_hz_temp * faktor);
				}
				else if (band == 3)									// 40m
				{	
					if ((freq_hz + freq_hz_temp * faktor) >= 7200000)// max. Frequenz erreicht
						freq_hz = freq_hz + (freq_hz_temp * faktor) - 200000;
					else if ((freq_hz + freq_hz_temp * faktor) < 7000000)// min Frequenz erreicht
						freq_hz += (freq_hz_temp * faktor) + 200000;
					else 											// zwischen den Grenzfrequenzen
						freq_hz += (freq_hz_temp * faktor);
				}
				else if (band == 4)									// 30m
				{	
					if ((freq_hz + freq_hz_temp * faktor) >= 10150000)// max. Frequenz erreicht
						freq_hz = freq_hz + (freq_hz_temp * faktor) - 50000;
					else if ((freq_hz + freq_hz_temp * faktor) < 10100000)// min Frequenz erreicht
						freq_hz += (freq_hz_temp * faktor) + 50000;
					else 											// zwischen den Grenzfrequenzen
						freq_hz += (freq_hz_temp * faktor);
				}
				else if (band == 5)									// 20m
				{	
					if ((freq_hz + freq_hz_temp * faktor) >= 14350000)// max. Frequenz erreicht
						freq_hz = freq_hz + (freq_hz_temp * faktor) - 350000;
					else if ((freq_hz + freq_hz_temp * faktor) < 14000000)// min Frequenz erreicht
						freq_hz += (freq_hz_temp * faktor) + 350000;
					else 											// zwischen den Grenzfrequenzen
						freq_hz += (freq_hz_temp * faktor);
				}
				else if (band == 6)									// 17m
				{	
					if ((freq_hz + freq_hz_temp * faktor) >= 18168000)// max. Frequenz erreicht
						freq_hz = freq_hz + (freq_hz_temp * faktor) - 100000;
					else if ((freq_hz + freq_hz_temp * faktor) < 18068000)// min Frequenz erreicht
						freq_hz += (freq_hz_temp * faktor) + 100000;
					else 											// zwischen den Grenzfrequenzen
						freq_hz += (freq_hz_temp * faktor);
				}
				else if (band == 7)									// 15m
				{	
					if ((freq_hz + freq_hz_temp * faktor) >= 21450000)// max. Frequenz erreicht
						freq_hz = freq_hz + (freq_hz_temp * faktor) - 450000;
					else if ((freq_hz + freq_hz_temp * faktor) < 21000000)// min Frequenz erreicht
						freq_hz += (freq_hz_temp * faktor) + 450000;
					else 											// zwischen den Grenzfrequenzen
						freq_hz += (freq_hz_temp * faktor);
				}
				else if (band == 8)									// 12m
				{	
					if ((freq_hz + freq_hz_temp * faktor) >= 24990000)// max. Frequenz erreicht
						freq_hz = freq_hz + (freq_hz_temp * faktor) - 100000;
					else if ((freq_hz + freq_hz_temp * faktor) < 24890000)// min Frequenz erreicht
						freq_hz += (freq_hz_temp * faktor) + 100000;
					else 											// zwischen den Grenzfrequenzen
						freq_hz += (freq_hz_temp * faktor);
				}
				else if (band == 9)									// 10m
				{	
					if ((freq_hz + freq_hz_temp * faktor) >= 29700000)// max. Frequenz erreicht
						freq_hz = freq_hz + (freq_hz_temp * faktor) - 1700000;
					else if ((freq_hz + freq_hz_temp * faktor) < 28000000)// min Frequenz erreicht
						freq_hz += (freq_hz_temp * faktor) + 1700000;
					else 											// zwischen den Grenzfrequenzen
						freq_hz += (freq_hz_temp * faktor);
				}
				else if (band == 10)								// 6m
				{	
					if ((freq_hz + freq_hz_temp * faktor) >= 52000000)// max. Frequenz erreicht
						freq_hz = freq_hz + (freq_hz_temp * faktor) - 1920000;
					else if ((freq_hz + freq_hz_temp * faktor) < 50080000)// min Frequenz erreicht
						freq_hz += (freq_hz_temp * faktor) + 1920000;
					else 											// zwischen den Grenzfrequenzen
						freq_hz += (freq_hz_temp * faktor);
				}
				freq_hz_temp = 0;

				lcd_gotoxy(3, 1);				// 2. Zeile mittig
				if (freq_hz < 10000000)
				{
					lcd_puts(" ");				// Leerzeichen bei kleiner als 10 MHz
				}
				bitvar.freq_update = 1;			// Frequenznderung
				freq_counter = 0;
				Frequenz_to_Array(freq_hz);		// umrechnen nach Array
				lcd_puts((char*)&frequenz);		// ausgeben auf LCD
				convertDDS(freq_hz);			// Ausgabe der Frequenz zum DDS
			}

			if (key != 0)						// bei Tastendruck
			{
				if (bitvar.tx_on == 0)			// Sender aus
				{
					if (bitvar.menu_aktiv == 0) // kein Men aktiviert
					{
						if ((key == 21) && (bitvar.freq_input == 0))// nur aufrufen wenn kein anderes Men aktiv oder Sender an
							MENUE_HAUPT(key, 1);
						if ((key == 15) || (key == 20) || (key == 25) || (key == 14) || (key == 19) || (key == 24) || 
							(key == 13) || (key == 18) || (key == 23) || (key == 17) || (key == 22) || (key == 12))
							frequenz_eingabe(key);
						if (bitvar.freq_input == 0)					// nur aufrufen wenn kein anderes Menu aktiv ist
						{
							if (key == 2)
								ATTENUATOR();
//							else if (key == 10)						// Taste MHz up
//								MHz(key);
//							else if (key == 5)						// Taste MHz down
//								MHz(key);
							else if (key == 1)						// Taste Mode
								Mode(key, 1);
							else if (key == 4)						// Band up
								Band(key);
							else if (key == 9)						// Band down
								Band(key);
							else if (key == 6)						// Blockieren des VFO Drehknopfs
								Lock();
							else if (key == 16)						// VFO A oder B
								VFO_AB();
							else if (key == 7)						// RIT
								rit_LED();
							else if (key == 8)						// XIT
								xit_LED();
						}
					}
					else
						MENUE_HAUPT(key, 0);
				}
				key = 0;
			}
	    }
}


///////////////////////////////////////////////////////////////////////////////
//
//	Interrupts Routine fr den 8bit Timer
//	Alle 200 us wird die Routine aufgerufen
//
///////////////////////////////////////////////////////////////////////////////
ISR(TIMER0_COMP_vect)           						// 200 us for manual movement
{
	uint8_t new, diff, new2, diff2 = 0;
//	uint16_t faktor = 20;

	if (bitvar.menu_aktiv == 0) 						// kein Men aktiviert
	{
		if (!(PIND & (1<<PIND3)) && bitvar.tx_on == 0)	// fallende Flanke (Pin D3 = 0) und Sender aus dann Sender an
		{
			bitvar.tx_on = 1;							// Sender an
			bitvar.ptt_schalten = 1;
		}
		else if (PIND & (1<<PIND3) && (bitvar.tx_on == 1))// steigende Flanke (Pin D3 = 1) dann Sender aus
		{		
			bitvar.tx_on = 0;							// Sender aus
			bitvar.ptt_schalten = 1;
		}
	}

	// Hauptencoder auslesen
	new = 0;
	if	(PHASE_B)
		new = 3;
	if	(PHASE_A)
		new ^= 1;           	 					    // convert gray to binary
	diff = last - new;      							// difference last - new
	if( diff & 1 )										// bit 0 = value (1)
	{
		last = new;                 					// store new as next last
		enc_delta += (diff & 2) - 1;        			// bit 1 = direction (+/-)
	}	// Hauptencoder auslesen ENDE

	// Drehencoder auslesen fr RIT/XIT
	new2 = 0;
	if	(PHASE_B2)
		new2 = 3;
	if	(PHASE_A2)
		new2 ^= 1;           	 					    // convert gray to binary
	diff2 = last2 - new2;      							// difference last - new
	if( diff2 & 1 )										// bit 0 = value (1)
	{
		last2 = new2;                 					// store new as next last
		enc_delta2 += (diff2 & 2) - 1;        			// bit 1 = direction (+/-)
	}	// Drehencoder auslesen fr RIT/XIT ENDE

	if (bitvar.freq_update == 1)						// Frequenznderung
		freq_counter++;									// warte 3 s
	else 												// keine nderung
		freq_counter = 0;
	if (freq_counter == 15000)							// alle ca. 3s nach Frequenznderung im EEPROM speichern
	{
		save_band(freq_hz);								// speichere Frequenz im passenden Band
		freq_counter = 0;								// lsche Zhler
		bitvar.freq_update = 0;							// nderung gespeichert
	}

	encoder_counter++;
	if (encoder_counter == 250) 						// every 50 ms
	{
		encoder_counter = 0;
		bitvar.freq_update_lcd = 1;						// LCD Frequenz ndern
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//	Interrupt Routine fr die Tastenabfrage
//	- reagiert sofort nach dem Drcken der Taste
//
///////////////////////////////////////////////////////////////////////////////
ISR(INT2_vect)
{
	if (edge = 0)
	{
		_delay_ms(20);
		EICRA |= (1 << 4) | (1 << 5);		// Int2 steigende Flanke
		edge = 1;
		EIFR |= (1 << 2);
	}
	else 
	{
		_delay_ms(30);
		key = Read_keyboard();
		init_keyboard();
		edge = 0;
		EICRA &= ~(1 << 4);					// Int2 fallende Flanke
		EIFR |= (1 << 2);
	}
}



//temp = Tx_Relais;
//sprintf(Buffer, "mode: %3i ", mode);
//lcd_gotoxy(0,0); lcd_puts(Buffer);
//sprintf(Buffer, "Rx%5i ", Rx_Relais);lcd_puts(Buffer);

//     char Buffer[20]; // in diesem {} lokal
//     itoa( rit_hz, Buffer, 10 ); 
//	 lcd_gotoxy(0,0);
//     lcd_puts( Buffer );


// Relais zum Filtervermessen dauerhaft setzen
//Tx_Relais |= Rx_an;
