// Ausleseneiner 5x5 Tastatur
//
// Marcus Pool
//
// www.Marcus-Pool.de
//
// Revision: 0.1
// 
//

#include <main.h>
#include <avr/io.h>
#include <avr/interrupt.h>

///////////////////////////////////////////////////////////////////////////////
//
// Initialisiert die Matrixtastatur
//
///////////////////////////////////////////////////////////////////////////////

void init_keyboard (void)
{
	// PORT C Pin 7 - 3 als Eingang und andere im ursprnglichen Zustand belassen:
	DDRC &= ~((1<<Col1) | (1<<Col2) | (1<<Col3) | (1<<Col4) | (1<<Col5));
	// Bei allen Eingngen die Pull ups einschalten
	PORTC |= ((1<<Col1) | (1<<Col2) | (1<<Col3) | (1<<Col4) | (1<<Col5));


	// PORT C Pin 2 - 0 und PORT D Pin 7, 6 als Ausgang, und andere im ursprnglichen Zustand belassen:
	DDRC |= ((1<<Row1) | (1<<Row2) | (1<<Row3));
	DDRD |= ((1<<Row4) | (1<<Row5));
	// Ausgnge auf 1
// 	PORTC |= ((1<<Row1) | (1<<Row2) | (1<<Row3));
//	PORTD |= ((1<<Row4) | (1<<Row5));

 	PORTC &= ~((1<<Row1) | (1<<Row2) | (1<<Row3));
	PORTD &= ~((1<<Row4) | (1<<Row5));
}



///////////////////////////////////////////////////////////////////////////////
//
// Liest die Matrixtastatur aus
//
/////////////////////////////////////////////////////////////////////////////////

int Read_keyboard (void)
{
	int i = 0;
	// PORT C Pin 7 - 3 als Eingang und andere im ursprnglichen Zustand belassen:
	DDRC &= ~((1<<Col1) | (1<<Col2) | (1<<Col3) | (1<<Col4) | (1<<Col5));
	// Bei allen Eingngen die Pull ups einschalten
	PORTC |= ((1<<Col1) | (1<<Col2) | (1<<Col3) | (1<<Col4) | (1<<Col5));

	// PORT C Pin 2 - 0 und PORT D Pin 7, 6 als Ausgang, und andere im ursprnglichen Zustand belassen:
	DDRC |= ((1<<Row1) | (1<<Row2) | (1<<Row3));
	DDRD |= ((1<<Row4) | (1<<Row5));
	// Ausgnge auf 1
 	PORTC |= ((1<<Row1) | (1<<Row2) | (1<<Row3));
	PORTD |= ((1<<Row4) | (1<<Row5));

	for (i = 0;i <= 4;i++)
	{
		switch (i)
		{
			case 0:
				PORTC &= ~(1<<Row1);
				break;
			case 1:
				// zweite Reihe = 0
				PORTC |= (1<<Row1);			// Reihe 1 wieder auf 1 setzen
				PORTC &= ~(1<<Row2);
				break;
			case 2:
				// dritte Reihe = 0
				PORTC |= (1<<Row2);			// Reihe 2 wieder auf 1 setzen
				PORTC &= ~(1<<Row3);
				break;
			case 3:
				// vierte Reihe = 0
				PORTC |= (1<<Row3);			// Reihe 3 wieder auf 1 setzen
				PORTD &= ~(1<<Row4);
				break;
			case 4:
				// fnfte Reihe = 0
				PORTD |= (1<<Row4);			// Reihe 4 wieder auf 1 setzen
				PORTD &= ~(1<<Row5);
			break;
			default:
				return 0;
				break;
		}
				if (!(PINC & (1<<Col1)))	// zweimal abrfragen damit es klappt
					return (i * 5 + 1);
				if (!(PINC & (1<<Col1)))
					return (i * 5 + 1);
				if (!(PINC & (1<<Col2)))	
					return (i * 5 + 2);
				if (!(PINC & (1<<Col3)))
					return (i * 5 + 3);
				if (!(PINC & (1<<Col4)))
					return (i * 5 + 4);
				if (!(PINC & (1<<Col5)))
					return (i * 5 + 5);
	}
	return 0;	
}
